#include "gcd.h"
#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
typedef unsigned long long ull;

const ull MAXN = 1000000003;

vector<ull> primes;
int sz = 0;

void init(ull from = 2, ull to = MAXN)
{
    for (ull i = from; i <= to; ++i)
    {
        bool is_prime = 1;
        for (int j = 0; j < sz; ++j)
            if (i % primes[j] == 0)
            {
                is_prime = 0;
                break;
            }

        if (is_prime)
        {
            primes.push_back(i);
            ++sz;
        }
    }
}

ull query(ull a, ull b);

ull play(ull MAX_X)
{
    if (primes.empty())
        init(2, MAX_X);
    ull ret = 1;
    bool not_null = 0;

    for (int i = 0; i < sz; ++i)
    {
        ull tmp = 1;
        while (tmp * primes[i] < MAX_X * 2)
            tmp *= primes[i];

        ull q = query(0, tmp);
        //cout << tmp << " " << primes[i] << " " << q << endl;

        if (tmp != q)
            not_null = 1;

        ret *= q;

        if (q == MAX_X)
            return MAX_X;

        if (q > MAX_X)
        {
            return 0;
        }
    }

    //cout << ret << endl;

    return ret;
}


//int main()
//{
//    ios_base::sync_with_stdio(false);
//    cin.tie(NULL);
//    cout.tie(NULL);
//
//
//    return 0;
//}
