#include <bits/stdc++.h>
//#define endl '\n'
using namespace std;

const int MOD = 1000000007;

int n, m, k;
string str;
const int MAXL = 26;
int step[MAXL][MAXL];
int groups[2][MAXL][MAXL];
int cnt[MAXL];

void input()
{
    cin >> str;
    k = str.size();
    cin >> n >> m;

    for (int i = 0; i < MAXL; ++i)
        for (int j = 0; j < MAXL; ++j)
            step[i][j] = -1;

    for (int i = 0; i < m; ++i)
    {
        string rule;
        char ch;
        cin >> rule >> ch;
        int prev = rule[0] - 'A';
        int tmp = rule[1] - 'A';
        int c = ch - 'A';

        step[prev][tmp] = c;
    }

    for (int i = 1; i < k; ++i)
    {
        int last = str[i - 1] - 'A';
        int tmp = str[i] - 'A';
        ++groups[0][last][tmp];
    }
}

void solve()
{
    for (int i = 0; i < k; ++i)
        ++cnt[str[i] - 'A'];

//    cout << "** " << endl;

    int idx = 0;
    for (int i = 0; i < n; ++i)
    {
//        cout << i << ": " << endl;

        for (int j = 0; j < MAXL; ++j)
            for (int t = 0; t < MAXL; ++t)
            {
                if (step[j][t] != -1)
                {
                    int added = step[j][t];
                    int groups_cnt = groups[idx][j][t];

                    cnt[added] += groups_cnt;
                    cnt[added] %= MOD;

                    groups[idx ^ 1][j][added] += groups_cnt;
                    groups[idx ^ 1][j][added] %= MOD;

                    groups[idx ^ 1][added][t] += groups_cnt;
                    groups[idx ^ 1][added][t] %= MOD;
                }
            }

        for (int j = 0; j < MAXL; ++j)
            for (int t = 0; t < MAXL; ++t)
                groups[idx][j][t] = 0;
        idx ^= 1;
    }

    for (int i = 0; i < MAXL; ++i)
        cout << char('A' + i) << " " << cnt[i] << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
