#include<bits/stdc++.h>
#define pb push_back
using namespace std;
int n;
vector<int> v[100001];
int p[100001];
int col[100001];
int _beg[100001];
int _end[100001];
int dep[100001];
int block[100001],bl_sz;
struct node{int updc,tc,upda,ta;};
node segtr[(1<<20)];
int trsz=(1<<20);
int leaf(int x)
{
    return x+trsz/2;
}
int _time=0;
void upd_col(int l,int r,int c)
{
    _time++;
    l=leaf(l);
    r=leaf(r);
    segtr[l].updc=c;
    segtr[l].tc=_time;
    segtr[r].updc=c;
    segtr[r].tc=_time;
    while((l/2)!=(r/2))
    {
        if(!(l&1))
        {
            segtr[l+1].updc=c;
            segtr[l+1].tc=_time;
        }
        if(r&1)
        {
            segtr[r-1].updc=c;
            segtr[r-1].tc=_time;
        }
        l>>=1;
        r>>=1;
    }
}
void upd_ans(int l,int r,int a)
{
    _time++;
    l=leaf(l);
    r=leaf(r);
    segtr[l].upda=a;
    segtr[l].ta=_time;
    segtr[r].upda=a;
    segtr[r].ta=_time;
    while((l/2)!=(r/2))
    {
        if(!(l&1))
        {
            segtr[l+1].upda=a;
            segtr[l+1].ta=_time;
        }
        if(r&1)
        {
            segtr[r-1].upda=a;
            segtr[r-1].ta=_time;
        }
        l>>=1;
        r>>=1;
    }
}
int get_col(int x)
{
    x=leaf(x);
    int c=segtr[x].updc;
    int t=segtr[x].tc;
    x>>=1;
    while(x)
    {
        if(segtr[x].tc>t)
        {
            c=segtr[x].updc;
            t=segtr[x].tc;
        }
        x>>=1;
    }
    return c;
}
int get_ans(int x)
{
    x=leaf(x);
    int a=segtr[x].upda;
    int t=segtr[x].ta;
    x>>=1;
    while(x)
    {
        if(segtr[x].ta>t)
        {
            a=segtr[x].upda;
            t=segtr[x].ta;
        }
        x>>=1;
    }
    return a;
}
int ind=0;
void dfs(int x,int pr=1,int d=0,int pr_bl=1)
{
    p[x]=pr; dep[x]=d;
    block[x]=pr_bl;
    if(d%bl_sz==0) pr_bl=x;
    _beg[x]=ind++;
    for(int y:v[x]) if(y!=pr) dfs(y,x,d+1,pr_bl);
    _end[x]=ind++;
}
void col_dfs(int x,int br=0)
{
    if(col[x]!=col[p[x]]) br++;
    upd_col(_beg[x],_end[x],col[x]);
    upd_ans(_beg[x],_end[x],br);
    for(int y:v[x]) if(y!=p[x]) col_dfs(y,br);
}
int lca(int a,int b)
{
    while(block[a]!=block[b])
    {
        if(dep[a]>=dep[b]) a=block[a];
        else b=block[b];
    }
    while(a!=b)
    {
        if(dep[a]>=dep[b]) a=p[a];
        else b=p[b];
    }
    return a;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin>>n; bl_sz=(int)sqrt(n);
    for(int i=1;i<n;i++)
    {
        int a,b;
        cin>>a>>b;
        v[a].pb(b);
        v[b].pb(a);
    }
    dfs(1);
    for(int i=1;i<=n;i++) cin>>col[i];
    col_dfs(1);
    int q;
    cin>>q;
    for(;q--;)
    {
        int t,u,v,c;
        cin>>t;
        if(t==1)
        {
            cin>>u>>v>>c;
            int x=lca(u,v);
            /*while(u!=x){col[u]=c; u=p[u];}
            while(v!=x){col[v]=c; v=p[v];}
            col[x]=c;
            calc();*/
        }
        else if(t==2)
        {
            cin>>u>>c;
            upd_col(_beg[u],_end[u],c);
            int a=get_ans(_beg[p[u]]);
            int c=get_col(_beg[p[u]]);
            if(c!=get_col(_beg[u])) a++;
            upd_ans(_beg[u],_end[u],a);
        }
        else if(t==3)
        {
            cin>>u>>v;
            int x=lca(u,v);
            cout<<get_ans(_beg[u])+get_ans(_beg[v])-2*get_ans(_beg[x])<<endl;
        }
    }
    return 0;
}
/**

6
1 2
2 6
2 3
3 4
3 5
1 1 3 1 2 1
5
3 6 4
1 6 4 2
3 1 5
2 2 4
3 3 5

*/
