#include "gcd.h"
#define ull unsigned long long
#include<vector>
#include<cstdlib>
#include<time.h>
#include<algorithm>
#include<iostream>

using namespace std;

vector<int> tests = {64, 81, 25, 49, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 91, 97};
vector<int> base = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 91, 97};

ull play(ull MAX_X){
    srand(time(nullptr));
    if(MAX_X>100){
        ull z=query(MAX_X+1, MAX_X+1);
        if(z==MAX_X+1){
            return 0;
        }
        ull ans=1;
        for(int i=0;i<500;i++){
            ull num=rand()%MAX_X;
            ull a = query(num, num);
            ans=ans*a/__gcd(ans, a);
        }
        //cout<<ans<<endl;
        int rans=ans;
        for(int i=ans;i<MAX_X;i+=ans){
            int cq=query(i,i);
            if(cq>rans){
                rans=cq;
            }
        }
        return rans;
    }
    ull ans=1;
    for(int i=0;i<tests.size() && ans*base[i]<MAX_X;i++){
        ull mult = query(tests[i], tests[i]);
        ans*=mult;
    }
    int a=query(ans*2, ans*2);
    if(a==ans*2)return 0;
    return ans;
}

/*int main()
{
    return 0;
}
*/
