#include<iostream>
#define LTRS 15
using namespace std;

struct matrix{
    int n;
    int matrix[1000][1000];
};

matrix mult(matrix a, matrix b){
    matrix result;
    int n=a.n;
    result.n=n;
    for(int y=0;y<n;y++){
        for(int x=0;x<n;x++){
            result.matrix[x][y]=0;
            for(int k=0;k<n;k++){
                result.matrix[x][y]+=a.matrix[k][y]*b.matrix[x][k];
            }
        }
    }
    return result;
}

matrix susedi, paths;

int letters[26];
int main(){
    string init;
    cin>>init;
    int n,m;
    cin>>n>>m;
    susedi.n=LTRS*LTRS+LTRS;
    for(int i=0;i<m;i++){
        char a,b,c;
        cin>>a>>b>>c;
        //cout<<"change: "<<a<<b<<" "<<c<<endl;
        int from = (a-'A')*LTRS+(b-'A');
        int to1 = (a-'A')*LTRS+(c-'A');
        int to2 = (c-'A')*LTRS+(b-'A');
        int letter = LTRS*LTRS+(c-'A');
        susedi.matrix[from][to1]++;
        susedi.matrix[from][to2]++;
        susedi.matrix[from][letter]++;
    }
    for(int i=0;i<LTRS;i++){
        int letter = LTRS*LTRS+i;
        susedi.matrix[letter][letter]=1;
    }
    paths=susedi;
    for(int i=1;i<n;i++){
        paths=mult(paths,susedi);
    }
    for(int i=0;i<init.size();i++){
        letters[init[i]-'A']++;
    }

    for(int i=0;i<init.size()-1;i++){
        int from = (init[i]-'A')*LTRS+(init[i+1]-'A');
        for(int j=0;j<LTRS;j++){
            letters[j]+=paths.matrix[from][LTRS*LTRS+j];
        }
    }

    for(int i=0;i<26;i++){
        cout<<(char)('A'+i)<<" "<<letters[i]<<endl;
    }

    return 0;
}
