#include <bits/stdc++.h>
using namespace std;
const int MAX=100000;
struct st{
    int v, rev;
};
int colors[MAX], parent[MAX];
int main(){
ios_base::sync_with_stdio(false);
cin.tie(0);
int n;
cin>>n;
vector <int> nbrs[n];
for(int i=0;i<n-1;i++){
    int a, b;
    cin>>a>>b;
    a--;
    b--;
    nbrs[a].push_back(b);
    nbrs[b].push_back(a);
}
for(int i=0;i<n;i++){
    cin>>colors[i];
}
queue <st> qu;
qu.push({0, 0});
fill(parent, parent+n, -1);
while(!qu.empty()){
    int curr=qu.front().v;
    parent[curr]=qu.front().rev;
    qu.pop();
    for(int i=0;i<nbrs[curr].size();i++){
        if(parent[nbrs[curr][i]]==-1){
            qu.push({nbrs[curr][i], curr});
        }
    }
}
int q;
cin>>q;
for(int j=0;j<q;j++){
    int input;
    cin>>input;
    if(input==1){
        int u, v, c;
        cin>>u>>v>>c;
        u--;
        v--;
        if(u==v){
            colors[u]=c;
            continue;
        }
        int curr1=u, curr2=v;
        bool taken1[n], taken2[n];
        fill(taken1, taken1+n, false);
        fill(taken2, taken2+n, false);
        int commonVertex;
        while(true){
            taken1[curr1]=true;
            taken2[curr2]=true;
            if(taken2[curr1]){
                commonVertex=curr1;
                break;
            }
            if(taken1[curr2]){
                commonVertex=curr2;
                break;
            }
            curr1=parent[curr1];
            curr2=parent[curr2];
        }
        curr1=u;
        while(curr1!=commonVertex){
            colors[curr1]=c;
            curr1=parent[curr1];
        }
        curr2=v;
        while(curr2!=commonVertex){
            colors[curr2]=c;
            curr2=parent[curr2];
        }
        colors[commonVertex]=c;
    }
    if(input==2){
        int u, c;
        cin>>u>>c;
        u--;
        queue <int> q;
        q.push(u);
        bool taken[n];
        fill(taken, taken+n, false);
        while(!q.empty()){
            int curr=q.front();
            q.pop();
            colors[curr]=c;
            taken[curr]=true;
            for(int i=0;i<nbrs[curr].size();i++){
                if(!taken[nbrs[curr][i]] and nbrs[curr][i]!=parent[u]){
                    q.push(nbrs[curr][i]);
                }
            }
        }
    }
    if(input==3){
        int u, v;
        cin>>u>>v;
        u--;
        v--;
        if(u==v){
            cout<<"0\n";
            continue;
        }
        int curr1=u, curr2=v;
        bool taken1[n], taken2[n];
        fill(taken1, taken1+n, false);
        fill(taken2, taken2+n, false);
        int commonVertex;
        while(true){
            taken1[curr1]=true;
            taken2[curr2]=true;
            if(taken2[curr1]){
                commonVertex=curr1;
                break;
            }
            if(taken1[curr2]){
                commonVertex=curr2;
                break;
            }
            curr1=parent[curr1];
            curr2=parent[curr2];
        }
        int ans=0;
        int old1=u;
        curr1=parent[old1];
        while(old1!=commonVertex){
            if(colors[old1]!=colors[curr1]){
                ans++;
            }
            old1=curr1;
            curr1=parent[old1];
        }

        int old2=v;
        curr2=parent[old2];
        while(old2!=commonVertex){
            if(colors[old2]!=colors[curr2]){
                ans++;
            }
            old2=curr2;
            curr2=parent[old2];
        }
        cout<<ans<<"\n";
    }
}
return 0;
}
