#include <bits/stdc++.h>
using namespace std;
const int MAX=100000;
struct st{
    int v, rev;
};
struct str{
    int v, rev, lev;
};
int colors[MAX], parent[MAX], level[MAX];
int main(){
ios_base::sync_with_stdio(false);
cin.tie(0);
int n;
cin>>n;
vector <int> nbrs[n];
for(int i=0;i<n-1;i++){
    int a, b;
    cin>>a>>b;
    a--;
    b--;
    nbrs[a].push_back(b);
    nbrs[b].push_back(a);
}
for(int i=0;i<n;i++){
    cin>>colors[i];
}
queue <str> qu;
qu.push({0, 0, 0});
fill(parent, parent+n, -1);
while(!qu.empty()){
    int curr=qu.front().v;
    parent[curr]=qu.front().rev;
    level[curr]=qu.front().lev;
    qu.pop();
    for(int i=0;i<nbrs[curr].size();i++){
        if(parent[nbrs[curr][i]]==-1){
            qu.push({nbrs[curr][i], curr, level[curr]+1});
        }
    }
}
int q;
cin>>q;
for(int j=0;j<q;j++){
    int input;
    cin>>input;
    if(input==1){
        int u, v, c;
        cin>>u>>v>>c;
        u--;
        v--;
        if(u==v){
            colors[u]=c;
            continue;
        }
        int curr1=u, curr2=v;
        if(level[u]>level[v]){
            while(level[curr1]>level[v]){
                colors[curr1]=c;
                curr1=parent[curr1];
            }
        }
        if(level[v]>level[u]){
            while(level[curr2]>level[u]){
                colors[curr1]=c;
                curr2=parent[curr2];
            }
        }
        while(true){
            colors[curr1]=c;
            colors[curr2]=c;
            if(curr1==curr2){
                break;
            }
            curr1=parent[curr1];
            curr2=parent[curr2];
        }
    }
    if(input==2){
        int u, c;
        cin>>u>>c;
        u--;
        queue <int> q;
        q.push(u);
        bool taken[n];
        fill(taken, taken+n, false);
        while(!q.empty()){
            int curr=q.front();
            q.pop();
            colors[curr]=c;
            taken[curr]=true;
            for(int i=0;i<nbrs[curr].size();i++){
                if(!taken[nbrs[curr][i]] and nbrs[curr][i]!=parent[u]){
                    q.push(nbrs[curr][i]);
                }
            }
        }
    }
    if(input==3){
        int u, v;
        cin>>u>>v;
        u--;
        v--;
        if(u==v){
            cout<<"0\n";
            continue;
        }
        int ans=0;
        int curr1=u, curr2=v;
        if(level[u]>level[v]){
            while(level[curr1]>level[v]){
                if(colors[curr1]!=colors[parent[curr1]]){
                    ans++;
                }
                curr1=parent[curr1];

            }
        }
        if(level[v]>level[u]){
            while(level[curr2]>level[u]){
                if(colors[curr2]!=colors[parent[curr2]]){
                    ans++;
                }
                curr2=parent[curr2];
            }
        }
        while(true){
            if(curr1==curr2){
                break;
            }
            if(colors[curr1]!=colors[parent[curr1]]){
                ans++;
            }
            if(colors[curr2]!=colors[parent[curr2]]){
                ans++;
            }
            curr1=parent[curr1];
            curr2=parent[curr2];
        }
        cout<<ans<<"\n";
    }
}
return 0;
}
