#include<iostream>
#include<vector>
#include<set>
#include<unordered_set>
using namespace std;

int broiVarhove;
vector<int> sasedstvo[100010];

vector<int> deca[100010];
int bashta[100010];

int cvqt[100010];

int broiZaqvki;

unordered_set<int> visitedParvi;
unordered_set<int> visitedVtori;

void dfsDeca(int segashenVrah, int otKadeIdvame){
    bashta[segashenVrah] = otKadeIdvame;

    for(int i = 0; i < (int)sasedstvo[segashenVrah].size(); i++){
        if(sasedstvo[segashenVrah][i] != otKadeIdvame){
            deca[segashenVrah].push_back(sasedstvo[segashenVrah][i]);
            dfsDeca(sasedstvo[segashenVrah][i], segashenVrah);
        }
    }
}

int lca(int parviVrah, int vtoriVrah){

    visitedParvi.clear();
    visitedVtori.clear();

    int segParvi = parviVrah;
    int segVtori = vtoriVrah;

    int lowestCA = -1;

    while(true){
        visitedParvi.insert(segParvi);
        visitedVtori.insert(segVtori);

        if(visitedVtori.find(segParvi) != visitedVtori.end()){
            lowestCA = segParvi;
            break;
        }

        if(visitedParvi.find(segVtori) != visitedParvi.end()){
            lowestCA = segVtori;
            break;
        }

        if(segParvi != 1){
            segParvi = bashta[segParvi];
        }
        if(segVtori != 1){
            segVtori = bashta[segVtori];
        }
    }

    return lowestCA;
}

int broiSmenqniq(int otKade, int doKade){

    int lowestCA = lca(otKade, doKade);

    int zaParviq = 0;

    int segParvi = bashta[otKade];
    int predenCvqt = cvqt[otKade];

    while(segParvi != bashta[lowestCA]){
        if(cvqt[segParvi] != predenCvqt){
            zaParviq++;
        }
        predenCvqt = cvqt[segParvi];
        segParvi = bashta[segParvi];
    }

    int zaVtoriq = 0;

    int segVtori = bashta[doKade];
    predenCvqt = cvqt[doKade];

    while(segVtori != bashta[lowestCA]){
        if(cvqt[segVtori] != predenCvqt){
            zaVtoriq++;
        }
        predenCvqt = cvqt[segVtori];
        segVtori = bashta[segVtori];
    }

    return zaParviq + zaVtoriq;
}

void promeniPoPatq(int otKade, int doKade, int novCvqt){

    int lowestCA = lca(otKade, doKade);

    int segParvi = otKade;

    while(segParvi != bashta[lowestCA]){
        cvqt[segParvi] = novCvqt;
        segParvi = bashta[segParvi];
    }

    int segVtori = doKade;

    while(segVtori != bashta[lowestCA]){
        cvqt[segVtori] = novCvqt;
        segVtori = bashta[segVtori];
    }

}

void promeniVPoddarvoto(int segashenVrah, int novCvqt){

    cvqt[segashenVrah] = novCvqt;

    for(int i = 0; i < (int)deca[segashenVrah].size(); i++){
        promeniVPoddarvoto(deca[segashenVrah][i], novCvqt);
    }

}

vector<int> otgovori;

int main(){

    cin>>broiVarhove;

    for(int i = 0; i < broiVarhove - 1; i++){
        int otKade;
        int doKade;
        cin>>otKade>>doKade;

        sasedstvo[otKade].push_back(doKade);
        sasedstvo[doKade].push_back(otKade);
    }

    for(int i = 1; i <= broiVarhove; i++){
        cin>>cvqt[i];
    }

    dfsDeca(1, 0);

    cin>>broiZaqvki;

    for(int i = 0; i < broiZaqvki; i++){
        int tipZaqvka;
        cin>>tipZaqvka;

        if(tipZaqvka == 1){
            int otKade;
            int doKade;
            int novCvqt;

            cin>>otKade>>doKade>>novCvqt;

            promeniPoPatq(otKade, doKade, novCvqt);
        }else{
            if(tipZaqvka == 2){
                int poddarvotoNa;
                int novCvqt;

                cin>>poddarvotoNa>>novCvqt;

                promeniVPoddarvoto(poddarvotoNa, novCvqt);
            }else{
                int otKade;
                int doKade;
                cin>>otKade>>doKade;

                int otgTuka = broiSmenqniq(otKade, doKade);
                otgovori.push_back(otgTuka);
            }
        }
    }

    for(int i = 0; i < (int)otgovori.size(); i++){
        cout<<otgovori[i]<<endl;
    }

    return 0;
}
