#include<iostream>
#include<unordered_map>
#include<string>
#include<queue>
using namespace std;

string polymer;

int broiIteracii;
int broiPravila;

unordered_map<string, char> pravila;

int broiSreshtaniq[1024];

struct DanniZaDvoikata{
    string dvoika;
    int naKoqIteraciq;
};

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>polymer;

    cin>>broiIteracii>>broiPravila;

    for(int i = 0; i < broiPravila; i++){
        string mejduKakvo;
        char kakvo;

        cin>>mejduKakvo>>kakvo;

        pravila[mejduKakvo] = kakvo;
    }

    queue<DanniZaDvoikata> q;

    broiSreshtaniq[polymer[0]]++;
    for(int i = 1; i < (int)polymer.size(); i++){
        broiSreshtaniq[polymer[i]]++;
        string tukaDvoika = "";
        tukaDvoika += polymer[i - 1];
        tukaDvoika += polymer[i];

        if(pravila.find(tukaDvoika) != pravila.end()){
            q.push({tukaDvoika, 1});
        }
    }

    while(q.empty() == false){
        DanniZaDvoikata naiOtpred = q.front();
        q.pop();

        if(naiOtpred.naKoqIteraciq > broiIteracii){
            break;
        }

        if(pravila.find(naiOtpred.dvoika) != pravila.end()){
            char novaBukva = pravila[naiOtpred.dvoika];

            broiSreshtaniq[novaBukva]++;

            string parvaNova = "";
            parvaNova += naiOtpred.dvoika[0];
            parvaNova += novaBukva;

            string vtoraNova = "";
            vtoraNova += novaBukva;
            vtoraNova += naiOtpred.dvoika[1];

            q.push({parvaNova, naiOtpred.naKoqIteraciq + 1});
            q.push({vtoraNova, naiOtpred.naKoqIteraciq + 1});
        }
    }

    for(char i = 'A'; i <= 'Z'; i++){
        cout<<i<<" "<<broiSreshtaniq[i]<<endl;
    }

    return 0;
}
