#include <bits/stdc++.h>
//#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

long long const MAXN=10000000, mod = 1e9+7;
string st[200];
char ch[200];
long long n, m, z[MAXN], ans[MAXN];
vector<long long> v;
map<char, long long> mp;

void kmp(string s)
{
    long long l=0, r=0, k = 0;
    long long sz = s.size();
    for(long long i=3;i<sz;i++)
    {
        if(i<=r) k = min(r-i+1, z[i-l]);
        else k = 0;
        while(i+k < sz && s[k] == s[i+k])
        {
            k++;
        }
        z[i] = k;
        if(k == 2) v.push_back(i-3);
        if(i+k-1 > r)
        {
            l = i;
            r = i+k-1;
        }
    }
}

void read()
{
    string s;
    cin>>s;
    long long sz = s.size();
    cin>>n>>m;
    for(long long i=1;i<=m;i++)
    {
        cin>>st[i]>>ch[i];
    }
    string str;
    for(long long u=1;u<=n;u++)
    {
        sz = s.size();
        for(long long i=1;i<=m;i++)
        {
            str = st[i] + '#' + s;
            kmp(str);
            for(long long r=0;r<v.size();r++)
            {
                long long j = v[r];
                ans[j] = i;
            }
            v.clear();
            memset(z, 0, sizeof(z));
        }
        str = s[0];
        for(long long i=0;i<sz-1;i++)
        {
            if(ans[i])
            {
                str += ch[ans[i]];
            }
            str+=s[i+1];
        }
        s = str;
        memset(ans, 0, sizeof(ans));
        v.clear();
        str = "";
    }
    sz = s.size();
    for(long long i=0;i<26;i++)
    {
        mp[i+'A'] = 0;
    }
    for(long long i=0;i<sz;i++)
    {
        mp[s[i]]++;
        mp[s[i]]%=mod;
    }
    for(auto it = mp.begin(); it!=mp.end(); it++)
    {
        cout<<it -> first<<" "<<it -> second<<endl;
    }
}

int main()
{
    speed();
    read();
    return 0;
}
