#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const long long maxn = 200002;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
long long n,q;
vector<long long>v[maxn];
long long used[maxn];
long long color[maxn];
long long par[maxn];
long long tin[maxn];
long long lvl[maxn];
long long tree[maxn*4];
long long path[maxn*4];
long long lvl_path[maxn*4];
long long timer = 1;
void make_tree( long long i, long long l, long long r )
{
    if( l == r )
    {
        tree[i] = l;
        return;
    }
    long long m = ( l + r ) / 2;
    make_tree(i*2,l,m);
    make_tree(i*2+1,m+1,r);
    if( lvl_path[tree[i*2]] < lvl_path[tree[i*2+1]] ) tree[i] = tree[i*2];
    else tree[i] = tree[i*2+1];
    return;
}
long long query( long long i, long long l, long long r, long long ql, long long qr )
{
    if( l == ql && r == qr )
    {
        return tree[i];
    }
    long long m = ( l + r ) / 2;
    if( qr <= m ) return query(i*2,l,m,ql,qr);
    else if( ql > m ) return query(i*2+1,m+1,r,ql,qr);
    else
    {
        long long x = query(i*2,l,m,ql,m);
        long long y = query(i*2+1,m+1,r,m+1,qr);
        if( lvl_path[x] < lvl_path[y] ) return x;
        else return y;
    }
}
void dfs( long long w )
{
    used[w] = 1;
    tin[w] = timer;
    path[timer] = w;
    lvl_path[timer] = lvl[w];
    timer += 1;
    long long sz = v[w].size();
    for( long long i = 0; i < sz; i++ )
    {
        long long nb = v[w][i];
        if( used[nb] == 0 )
        {
            lvl[nb] = lvl[w] + 1;
            if( color[w] == color[nb] ) par[nb] = par[w];
            else par[nb] = par[w] + 1;
            dfs(nb);
            path[timer] = w;
            lvl_path[timer] = lvl[w];
            timer += 1;
        }
    }
    return;
}
void init_lca()
{
    lvl[1] = 1;
    dfs(1);
    make_tree(1,1,timer-1);
}
void read()
{
    cin >> n;
    for( long long i = 1; i < n; i ++ )
    {
        long long x,y;
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    for( long long i = 1; i <= n; i ++ )
    {
        cin >> color[i];
    }
    init_lca();
    cin >> q;
    for( long long i = 1; i <= q; i ++ )
    {
        long long t,x,y;
        cin >> t >> x >> y;
        if( t == 3 )
        {
            long long lca = path[query( 1, 1, timer-1, min(tin[x],tin[y]) , max(tin[x],tin[y]) )];
            long long ans = (par[x] - par[lca]) + ( par[y] - par[lca] );
            cout << ans << endl;
        }
    }
}
int main()
{
	speed();
	read();
    return 0;
}
