#include<bits/stdc++.h>
using namespace std;
const int MAXN=1e5+6;
const int lg=20;
vector<int>g[MAXN];
int par[MAXN][lg];
int uneq[MAXN];
int uneqpref[MAXN];
int dep[MAXN];
int color[MAXN];
void dfs_init(int u,int p)
{
    par[u][0]=p;
    for(int step=1;step<lg;step++)
    {
        par[u][step]=par[par[u][step-1]][step-1];
    }
    dep[u]=dep[p]+1;
    if(color[u]!=color[p])
    {
        uneq[u]=1;
    }
    uneqpref[u]=uneqpref[p]+uneq[u];
    //cout<<u<<" -> "<<uneqpref[u]<<endl;
    for(auto xd:g[u])
    {
        if(xd==p)continue;
        dfs_init(xd,u);
    }
}
int lca(int a,int b)
{
    if(dep[a]<dep[b])swap(a,b);
    int dif=dep[a]-dep[b];
    for(int i=0;i<lg;i++)
    {
        if(dif&(1<<i))
        {
            a=par[a][i];
        }
    }
    if(a==b)return a;
    for(int i=lg-1;i>=0;i--)
    {
        if(par[a][i]!=par[b][i])
        {
            a=par[a][i];
            b=par[b][i];
        }
    }
    return par[a][0];
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n,q;
    cin>>n;
    for(int i=1;i<n;i++)
    {
        int a,b;
        cin>>a>>b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for(int i=1;i<=n;i++)cin>>color[i];
    dfs_init(1,0);
    /*for(int i=1;i<=n;i++)
    {
        cout<<i<<" : "<<uneqpref[i]<<endl;
    }*/
    cin>>q;
    for(int i=0;i<q;i++)
    {
        int t,a,b;
        cin>>t>>a>>b;
        int l=lca(a,b);
        cout<<uneqpref[a]+uneqpref[b]-uneqpref[l]-uneqpref[l]<<endl;
    }
return 0;
}
