#include<bits/stdc++.h>
using namespace std;
#define ll long long
#pragma GCC optimize ("Ofast")
#pragma GCC target ("avx,avx2,fma")
const ll mod=1e9+7;
vector<vector<ll> >mult(vector<vector<ll> >a, vector<vector<ll> >b)
{
    vector<vector<ll> >ret;
    for(int i=0;i<a.size();i++)
    {
        ret.push_back({});
        for(int j=0;j<b[0].size();j++)
        {
            ret[i].push_back(0);
        }
    }
    for(int i=0;i<a.size();i++)
    {
        for(int k=0;k<b.size();k++)
        {
            for(int j=0;j<b[0].size();j++)
            {
                ret[i][j]+=(a[i][k]*b[k][j])%mod;
            }
        }
    }
    return ret;
}
map<string,int> numbers;
map<string,int> cnt;
string rnumbers[1000000];
int cntfirst[26];
int cntsecond[26];
vector<vector<ll> > fastpow(vector<vector<ll> > x,ll p)
{
    if(p==1)return x;
    vector<vector<ll> >t=fastpow(x,p/2);
    t=mult(t,t);
    if(p%2==1)
    {
        t=mult(t,x);
    }
    return t;
}
set<string>there_is_a_rule;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    string s;
    int n,m;
    cin>>s;
    cin>>n>>m;
    set<string>aha;
    vector<pair<string,char> >rules;
    for(int i=0;i<m;++i)
    {
        string p;
        char c;
        cin>>p>>c;
        there_is_a_rule.insert(p);
        rules.push_back({p,c});
        aha.insert(p);
        string ss1="";
        ss1+=p[0];
        ss1+=c;
        string ss2="";
        ss2+=c;
        ss2+=p[1];
        aha.insert(ss1);
        aha.insert(ss2);
    }
    int cntn=0;
    for(auto xd:aha)
    {
        rnumbers[cntn]=xd;
        numbers[xd]=cntn++;
    }
    for(int i=1;i<s.size();++i)
    {
        string ss="";
        ss+=s[i-1];
        ss+=s[i];
        ++cnt[ss];
    }
    vector<vector<ll> >starting;
    vector<vector<ll> >edges;
    for(int i=0;i<aha.size();++i)
    {
        if(i==0)starting.push_back({});
        edges.push_back({});
        for(int j=0;j<aha.size();++j)
        {
            if(i==0)starting[i].push_back({0});
            edges[i].push_back(0);
        }
    }
    for(auto xd:aha)
    {
        if(there_is_a_rule.find(xd)==there_is_a_rule.end())
        {
            edges[numbers[xd]][numbers[xd]]++;
        }
    }
    for(int i=0;i<aha.size();++i)
    {
        starting[0][i]=cnt[rnumbers[i]];
    }
    for(auto r:rules)
    {
        string beg=r.first;
        string res1="";
        string res2="";
        res1+=beg[0];
        res1+=r.second;
        res2+=r.second;
        res2+=beg[1];
        ++edges[numbers[beg]][numbers[res1]];
        ++edges[numbers[beg]][numbers[res2]];
    }
    /*cout<<"numbers:\n";
    for(auto xd:numbers)
    {
        cout<<xd.first<<" "<<xd.second<<endl;
    }
    cout<<endl;*/
    /*cout<<"edges:\n";
    for(int i=0;i<edges.size();i++)
    {
        for(int j=0;j<edges[i].size();j++)cout<<edges[i][j]<<" ";
        cout<<endl;
    }
    cout<<endl;*/
    /*cout<<"starting:\n";
    for(int i=0;i<starting.size();i++)
    {
        for(int j=0;j<starting[i].size();j++)cout<<starting[i][j]<<" ";
        cout<<endl;
    }
    cout<<endl;*/
    vector<vector<ll> >edges1=edges;
    //cout<<"eho\n";
    edges1=fastpow(edges1,n);
    /*for(int i=1;i<n;++i)
    {
        //cout<<i<<" ()"<<endl;
        edges1=mult(edges1,edges);
    }*/
    //cout<<"aha\n";
    /*cout<<"edges1:\n";
    for(int i=0;i<edges1.size();i++)
    {
        for(int j=0;j<edges1[i].size();j++)
        {
            cout<<edges1[i][j]<<" ";
        }
        cout<<endl;
    }
    cout<<endl;*/
    vector<vector<ll> >result=mult(starting,edges1);
    /*cout<<"result:\n";
    for(int i=0;i<result.size();i++)
    {
        for(int j=0;j<result[i].size();j++)
        {
            cout<<result[i][j]<<" ";
        }
        cout<<endl;
    }*/
    for(int i=0;i<result[0].size();++i)
    {
        cntfirst[rnumbers[i][0]-'A']+=result[0][i];
        cntfirst[rnumbers[i][0]-'A']%=mod;
        cntsecond[rnumbers[i][1]-'A']+=result[0][i];
        cntsecond[rnumbers[i][1]-'A']%=mod;
    }
    for(auto dx:cnt)
    {
        string xd=dx.first;
        if(numbers.count(xd)==0)
        {
            //cout<<"opa "<<xd<<" "<<cnt[xd]<<endl;
            cntfirst[xd[0]-'A']+=cnt[xd];
            cntfirst[xd[0]-'A']%=mod;
            cntsecond[xd[1]-'A']+=cnt[xd];
            cntsecond[xd[1]-'A']%=mod;
        }
    }
    for(int i=0;i<26;++i)
    {
        if(s[0]==char('A'+i))
        {
            if(s.back()==char('A'+i))
            {
                cout<<char('A'+i)<<" "<<(cntfirst[i]+1)%mod<<endl;
            }
            else
            {
                cout<<char('A'+i)<<" "<<cntfirst[i]<<endl;
            }
        }
        else
        {
            cout<<char('A'+i)<<" "<<cntsecond[i]<<endl;
        }
    }
return 0;
}
