#include<bits/stdc++.h>
using namespace std;

typedef long long ll;

const ll MAX=100100;

vector<ll> v[MAX],euler;
pair<ll,ll> dp[MAX][32];
ll timefirst[MAX];
ll binpar[MAX*8];
ll depth[MAX];
ll color[MAX];
ll par[MAX];
ll pows2[32];
ll n;

void makebintree(ll pos,ll l,ll r){
  if(l==r){
    binpar[pos]=euler[l];
    return ;
    }

  ll mid=(l+r)/2;
  makebintree(pos*2,l,mid);
  makebintree(pos*2+1,mid+1,r);
  if(depth[binpar[pos*2]]<depth[binpar[pos*2+1]])binpar[pos]=binpar[pos*2];
  else binpar[pos]=binpar[pos*2+1];
  }

ll querparans;
void querpar(ll pos,ll l,ll r,ll ql,ll qr){
  if(ql<=l && r<=qr){
    if(querparans==-1 || depth[binpar[pos]]<depth[querparans])querparans=binpar[pos];
    }
  else if(l>qr || r<ql)return ;
  else {
    ll mid=(l+r)/2;
    querpar(pos*2,l,mid,ql,qr);
    querpar(pos*2+1,mid+1,r,ql,qr);
    }
  }

ll qpar(ll a,ll b){
  querparans=-1;
  a=timefirst[a];
  b=timefirst[b];
  if(a>b)swap(a,b);
  querpar(1,0,euler.size()-1,a,b);
  return querparans;
  }

void dfspardeptheu(ll pos,ll p,ll d){
  par[pos]=p;
  depth[pos]=d;
  euler.push_back(pos);
  timefirst[pos]=euler.size()-1;
  for(ll i : v[pos]){
    if(i!=p){
      dfspardeptheu(i,pos,d+1);
      euler.push_back(pos);
      }
    }
  }

void colorsub(ll pos,ll c){
  color[pos]=c;
  for(ll i : v[pos]){
    if(i==par[pos])continue;
    colorsub(i,c);
    }
  }

void makedp(){
  for(ll i=1;i<=n;++i){
    if(i==1){dp[i][0]={-1,-1};continue;}
    dp[i][0].first=par[i];
    dp[i][0].second=color[i]!=color[par[i]];
    }

  for(ll j=1;j<32;++j){
    for(ll i=1;i<=n;++i){
      if(depth[i]-pows2[j]<=0){dp[i][j]={-1,-1};continue;}
      dp[i][j].first=dp[dp[i][j-1].first][j-1].first;
      dp[i][j].second=dp[i][j-1].second+dp[dp[i][j-1].first][j-1].second;
      }
    }

  //for(ll j=0;j<32;++j){
  //  for(ll i=1;i<=n;++i){
  //    cout<<i<<" "<<j<<" "<<dp[i][j].first<<" "<<dp[i][j].second<<endl;
  //    }
  //  }
  }

ll broiotdo(ll a,ll pa){
  ll c=depth[pa]-depth[a],res=0;

  for(ll i=0;c;++i){
    if(c%2){
      res+=dp[a][i].second;
      a=dp[a][i].first;
      }
    c/=2;
    }
  return res;
  }

int main(){

pows2[0]=1;
for(ll i=1;i<32;++i)pows2[i]=pows2[i-1]*2;

cin>>n;
for(ll i=1,x,y;i<n;++i){
  cin>>x>>y;
  v[x].push_back(y);
  v[y].push_back(x);
  }
for(ll i=1;i<=n;++i)cin>>color[i];

dfspardeptheu(1,-1,1);
makebintree(1,0,euler.size()-1);
makedp();

ll q;
cin>>q;
while(q--){
  ll t;
  cin>>t;

  if(t==3){
    ll a,b,pp;
    cin>>a>>b;
    pp=qpar(a,b);
    cout<<broiotdo(a,pp)+broiotdo(b,pp)<<endl;
    }
  }

return 0;
}
/*
6
1 2
2 6
2 3
3 4
3 5
1 1 3 1 2 1
6
3 6 4
3 1 5
3 3 5
3 6 5
3 6 3
3 6 1

6
1 2
2 6
2 3
3 4
3 5

*/
