#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

int n;
vector<int> gr[100006];

int segm_cv[400006];

void update_cv(int v, int le, int ri, int be, int en, int st)
{
    if(en<le || ri<be) return;
    if(be<=le && ri<=en) segm_cv[v]=st;
    else
    {
        int mid=(le+ri)/2;
        if(segm_cv[v])
        {
        segm_cv[2*v]=segm_cv[v];
        segm_cv[2*v+1]=segm_cv[v];
        }
        segm_cv[v]=0;
        update_cv(2*v, le, mid, be, en, st);
        update_cv(2*v+1, mid+1, ri, be, en, st);
    }
}

int query_cv(int v, int le, int ri, int pos)
{
    if(segm_cv[v]) return segm_cv[v];
    int mid=(le+ri)/2;
    if(pos<=mid) return query_cv(2*v, le, mid, pos);
    return query_cv(2*v+1, mid+1, ri, pos);
}


int chd[100006];
int par[100006], brv[100006], de[100006];

void dfs(int v)
{
    brv[v]=1;
    int brs=gr[v].size(), maxbr=0;
    for(int i=0; i<brs; i++)
    {
        int nv=gr[v][i];
        if(par[v]==nv) continue;
        de[nv]=de[v]+1;
        par[nv]=v;
        dfs(nv);
        brv[v]+=brv[nv];
        if(brv[nv]>maxbr)
        {
            maxbr=brv[nv];
            chd[v]=nv;
        }
    }
}

int tbrv=0;
int pos[100006];
int parch[100006];
int ddch[100006];
bool chvr[100006];
int id[2][100006];


void dfs2(int v, int parv)
{
    if(v==parv) chvr[v]=1;
    tbrv++;
    id[0][v]=tbrv;
    pos[v]=tbrv;
    parch[v]=parv;
    if(chd[v])
    {
        ddch[chd[v]]=ddch[v];
        dfs2(chd[v], parv);
    }
    int brs=gr[v].size();
    for(int i=0; i<brs; i++)
    {
        int nv=gr[v][i];
        if(nv!=par[v] && nv!=chd[v])
        {
            ddch[nv]=ddch[v]+1;
            dfs2(nv, nv);
        }
    }
    id[1][v]=tbrv;
}

int segm_st[400006];
int lazy_st[400006];

void push_lazy(int v, int le, int ri)
{
    if(lazy_st[v]==0) return;
    int prst=(lazy_st[v]+1)/2;
    segm_st[v]=(ri-le+1)*prst;
    if(le!=ri) lazy_st[2*v]=lazy_st[2*v+1]=lazy_st[v];
    lazy_st[v]=0;
}

void update_st(int v, int le, int ri, int be, int en, int st)
{
    push_lazy(v, le, ri);
    if(en<le || ri<be) return;
    else if(be<=le && ri<=en)
    {
        lazy_st[v]=st;
        push_lazy(v, le, ri);
    }
    else
    {
        int mid=(le+ri)/2;
        update_st(2*v, le, mid, be, en, st);
        update_st(2*v+1, mid+1, ri, be, en, st);
        segm_st[v]=segm_st[2*v]+segm_st[2*v+1];
    }
}

int query_st(int v, int le, int ri, int be, int en)
{
    push_lazy(v, le, ri);
    if(en<le || ri<be) return 0;
    else if(be<=le && ri<=en) return segm_st[v];
    else
    {
        int mid=(le+ri)/2;
        int q1=query_st(2*v, le, mid, be, en);
        int q2=query_st(2*v+1, mid+1, ri, be, en);
        return q1+q2;
    }
}


void query1()
{
    int v1, v2, cv;
    cin>>v1>>v2>>cv;
    while(parch[v1]!=parch[v2])
    {
        if(ddch[v1]<ddch[v2]) swap(v1, v2);
        int np=parch[v1];
        if(np!=v1)
        {
            update_cv(1, 1, n, pos[np], pos[v1], cv);
            update_st(1, 1, n, pos[np], pos[v1], -1);
        }
        v1=par[np];
    }
    if(v1==v2) return;
    if(de[v1]<de[v2]) swap(v1, v2);
    update_cv(1, 1, n, pos[v2], pos[v1], cv);
    update_st(1, 1, n, pos[v2]+1, pos[v1], -1);
    if(parch[v2]!=v2)
    {
        int v3=par[v2];
        if(query_cv(1, 1, n, v2)==query_cv(1, 1, n, v3)) update_st(1, 1, n, pos[v2], pos[v2], -1);
        else update_st(1, 1, n, pos[v2], pos[v2], 1);
    }
}

void query2()
{
    int v1, cv;
    cin>>v1>>cv;
    update_cv(1, 1, n, id[0][v1], id[1][v1], cv);
    if(parch[v1]!=v1)
    {
        int v2=par[v1];
        if(query_cv(1, 1, n, v1)==query_cv(1, 1, n, v2)) update_st(1, 1, n, pos[v1], pos[v1], -1);
        else update_st(1, 1, n, pos[v1], pos[v1], 1);
    }
    if(chd[v1]) update_st(1, 1, n, id[0][v1]+1, id[1][v1], -1);
}

void query3()
{
    int res=0;
    int v1, v2;
    cin>>v1>>v2;
    while(parch[v1]!=parch[v2])
    {
       /** cout<<"otg:\n";
        cout<<v1<<" "<<v2<<" "<<res<<endl;*/
        if(ddch[v1]<ddch[v2]) swap(v1, v2);
        int np=parch[v1];
        if(np!=v1) res+=query_st(1, 1, n, pos[np], pos[v1]);
        if(query_cv(1, 1, n, pos[np])!=query_cv(1, 1, n, pos[par[np]])) res++;
        v1=par[np];
    }
       /** cout<<"otg2:\n";
        cout<<v1<<" "<<v2<<" "<<res<<endl;*/
    if(v1==v2) {cout<<res<<endl; return;}
    if(de[v1]<de[v2]) swap(v1, v2);
    cout<<res+query_st(1, 1, n, pos[v2]+1, pos[v1])<<endl;

}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=1; i<n; i++)
    {
        int v1, v2;
        cin>>v1>>v2;
        gr[v1].push_back(v2);
        gr[v2].push_back(v1);
    }
    par[1]=1;
    de[1]=1;
    ddch[1]=1;
    dfs(1);
    dfs2(1, 1);
    for(int i=1; i<=n; i++)
    {
        int cv;
        cin>>cv;
        update_cv(1, 1, n, pos[i], pos[i], cv);
    }
    for(int i=2; i<=n; i++)
    {
        if(!chvr[i] && query_cv(1, 1, n, pos[i])!=query_cv(1, 1, n, pos[par[i]])) update_st(1, 1, n, pos[i], pos[i], 1);
    }
    int m;
    cin>>m;
    for(int i=0; i<m; i++)
    {
        int t;
        cin>>t;
        if(t==1) query1();
        if(t==2) query2();
        if(t==3) query3();
    }
    return 0;
}
/**
13
1 3
3 7
11 10
10 7
13 6
6 5
6 12
5 3
1 8
8 2
4 2
9 2
1 2 1 4 5 1 2 3 4 5 1 2 3
5
3 1 2
3 7 8
3 11 9
3 13 4
3 1 1

*/
