#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX = 1e5+5;

vector <int> G[MAX];
int col[MAX];
int n;

bool used[MAX];
int ans3 = 0;
int tmp = 0;

void dfs(int s, int to)
{
    if (used[s]) return;
    used[s] = 1;
//    cerr << tmp << endl;
    if (s == to)
    {
        if (col[s] != col[to]) tmp++;
        ans3 = tmp;
        return;
    }
    for (int i = 0; i < G[s].size(); i++)
    {
        int si = G[s][i];
        if (col[s] != col[si]) tmp++;

        dfs(si, to);

        if (col[s] != col[si]) tmp--;
    }
}

int query3(int a, int b)
{
    memset(used, 0, sizeof(used));
    tmp = 0;
    dfs(a, b);
    return ans3;
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    for (int i = 1; i < n; i++)
    {
        int a, b;
        cin >> a >> b;
        G[a].push_back(b);
        G[b].push_back(a);
    }

    for (int i = 1; i <= n; i++)
        cin >> col[i];

    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        int type;
        cin >> type;
        if (type == 3)
        {
            int a, b;
            cin >> a >> b;
            cout << query3(a, b) << endl;
        }
    }

    return 0;
}
/**
6
1 2
2 6
2 3
3 4
3 5
1 1 3 1 2 1
5
3 6 4
1 6 4 2
3 1 5
2 2 4
3 3 5



6
1 2
2 6
2 3
3 4
3 5
1 1 3 1 2 1
1
3 6 4

*/
