#include <iostream>
#include "gcd.h"
using namespace std;

typedef unsigned long long ull;

ull query(ull a, ull b);

ull play(ull MAX_X)
{
    ull b = 1;
    while (b < MAX_X) b <<= 1;

    ull a = 0, c = b, q;
    while ((q = query(a + c, b)) != b)
    {
        a += q;
        c -= 2 * q;
        if (q == b / 2) break;
    }
    return (b - (a + c)) % b;
}