#include <iostream>
using namespace std;
const int MAXN=677;
const long long mod=1e9+7;
int ma[256], kop[128][3], ma_co[MAXN];
char op[32], op_co[MAXN], q[MAXN];
long long start[MAXN], t[MAXN][MAXN], ans[256], cnt[MAXN];
long long res[MAXN][MAXN], d[MAXN][MAXN];
int br_let, br, br_co;
void mult(long long a[][MAXN], long long b[][MAXN], long long c[][MAXN]) {
    for (int i=0;i<br_co;i++) {
        for (int j=0;j<br_co;j++) d[i][j]=0;
    }
    for (int i=0;i<br_co;i++) {
        for (int j=0;j<br_co;j++) {
            for (int k=0;k<br_co;k++) {
                d[i][j]=(d[i][j]+a[i][k]*b[k][j])%mod;
            }
        }
    }
    for (int i=0;i<br_co;i++) {
        for (int j=0;j<br_co;j++) c[i][j]=d[i][j];
    }
}
void print_table(long long a[][MAXN]) {
    for (int i=0;i<br_co;i++) {
        for (int j=0;j<br_co;j++) {
            cout << a[i][j] << ' ';
        }
        cout << endl;
    }
}
void table_pow(int x) {
    while (x>0) {
        if (x%2==1) mult(t,res,res);
        ///print_table(t);
        mult(t,t,t);
        x/=2;
    }
    ///print_table(res);
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string str;
    int num1, num2;
    char c1, c2, c3;
    int n, m;
    cin >> str;
    cin >> n >> m;
    for (int i=0;i<256;i++) ma[i]=-1;
    br_let=0;
    for (int i=0;i<str.size();i++) {
        if (ma[str[i]]==-1) {
            ma[str[i]]=br_let;
            op[br_let]=str[i];
            br_let++;
        }
    }
    for (int i=0;i<m;i++) {
        cin >> c1 >> c2 >> c3;
        if (ma[c1]==-1) {
            ma[c1]=br_let;
            op[br_let]=c1;
            br_let++;
        }
        if (ma[c2]==-1) {
            ma[c2]=br_let;
            op[br_let]=c2;
            br_let++;
        }
        if (ma[c3]==-1) {
            ma[c3]=br_let;
            op[br_let]=c3;
            br_let++;
        }
        kop[i][0]=ma[c1];
        kop[i][1]=ma[c2];
        kop[i][2]=ma[c3];
    }
    br=br_let*br_let;
    for (int i=0;i<br;i++) ma_co[i]=q[i]=-1;
    br_co=0;
    for (int i=0;i<m;i++) {
        num1=kop[i][0]*br_let+kop[i][1];
        num2=kop[i][0]*br_let+kop[i][2];
        if (ma_co[num1]==-1) {
            ma_co[num1]=br_co;
            op_co[br_co]=num1;
            br_co++;
        }
        if (ma_co[num2]==-1) {
            ma_co[num2]=br_co;
            op_co[br_co]=num2;
            br_co++;
        }
        num1=ma_co[num1];
        num2=ma_co[num2];
        t[num1][num2]++;
        num2=kop[i][2]*br_let+kop[i][1];
        if (ma_co[num2]==-1) {
            ma_co[num2]=br_co;
            op_co[br_co]=num2;
            br_co++;
        }
        num2=ma_co[num2];
        t[num1][num2]++;
        q[num1]=op[kop[i][2]];
    }
    for (int i=0;i<br_co;i++) {
        if (q[i]==-1) t[i][i]=1;
        res[i][i]=1;
    }
    print_table(t);
    table_pow(n-1);
    for (int i=1;i<str.size();i++) {
        num1=ma[str[i-1]]*br_let;
        num1+=ma[str[i]];
        start[num1]++;
    }
    int i1, j1;
    for (int i=0;i<br_co;i++) {
        i1=op_co[i];
        if (start[i1]!=0) {
            for (int j=0;j<br_co;j++) {
                j1=op_co[j];
                cnt[j1]=(cnt[j1]+start[i1]*res[i][j1])%mod;
            }
        }
    }
    for (int i=0;i<br;i++) {
        c1=op[i/br_let];
        if (ma_co[i]==-1) {
            ans[c1]+=start[i];
            continue;
        }
        i1=ma_co[i];
        ///cout << c1 << ' ' << op[i%br_let] << ' ' << cnt[i1] << ' ' << i1 << endl;
        ans[c1]+=cnt[i1];
        if (q[i1]!=-1) ans[q[i1]]+=cnt[i1];
    }
    ans[str[str.size()-1]]++;
    for (int i=0;i<26;i++) {
        c1='A'+i;
        cout << c1 << ' ' << ans[c1]%mod << endl;
    }
    return 0;
}
/**
NBBN
3 3
NB N
BB N
BN N
**/
