#include <bits/stdc++.h>
using namespace std;
    vector<long long> A[100000];
    long long used[100000], rod[100000], n, m, cv[100000];
    queue<long long> q;
void bfs(long long k){
    used[k]=0;
    q.push(k);
    while (!q.empty()){
        int x=q.front();
        for (int i=0; i<A[x].size(); i++){
            if (used[A[x][i]]==-1){
                used[A[x][i]]=used[x]+1;
                rod[A[x][i]]=x;
                q.push(A[x][i]);
            }
        }
        q.pop();
    }
}
void task1(long long a, long long b, long long cvqt){
    if (used[a]<used[b]){swap(a, b);}
    cv[a]=cvqt;
    cv[b]=cvqt;
    while (used[a]>used[b]){
        a=rod[a];
        cv[a]=cvqt;
    }
    while (a!=b){
        a=rod[a];
        b=rod[b];
        cv[a]=cvqt;
        cv[b]=cvqt;
    }
}
void task2(long long a, long long cvqt){
    q.push(a);
    while (!q.empty()){
        int x=q.front();
        cv[x]=cvqt;
        for (int i=0; i<A[x].size(); i++){
            if (A[x][i]!=rod[x]){
                q.push(A[x][i]);
            }
        }
        q.pop();
    }
}
long long task3(long long a, long long b){
    long long br=0;
    if (used[a]<used[b]){swap(a, b);}
    while (used[a]>used[b]){
        if (cv[a]!=cv[rod[a]]){br++;}
        a=rod[a];
    }
    while (a!=b){
        if (cv[a]!=cv[rod[a]]){br++;}
        if (cv[b]!=cv[rod[b]]){br++;}
        a=rod[a];
        b=rod[b];
    }
    return br;
}

int main (){
ios_base::sync_with_stdio(false);
cin.tie(0);
cout.tie(0);
    long long i, j, a, b, c, d;
    cin >> n;
    for (i=0; i<n-1; i++){
        cin >> a >> b;
        a--;
        b--;
        A[a].push_back(b);
        A[b].push_back(a);
    }
    for (i=0; i<n; i++){
        cin >> cv[i];
        used[i]=-1;
    }
    bfs(0);
    rod[0]=-1;
    cin >> m;
    for (i=0; i<m; i++){
        cin >> a;
        if (a==1){
            cin >> b >> c >> d;
            b--;
            c--;
            task1(b, c, d);
        }
        if (a==2){
            cin >> b >> c;
            b--;
            task2(b, c);
        }
        if (a==3){
            cin >> b >> c;
            b--;
            c--;
            cout << task3(b, c) << endl;
        }
    }


return 0;
}
