#include "gcd.h"
#include <iostream>
#include <vector>
#include <algorithm>
typedef long long ll;
const ll base = 12, base2 = 4;

std::vector < ll > v[base], rem[base], ans;
std::vector < ll > v2[base], rem2[base];

ll log(ll x, ll base1)
{
    ll ans = 0;
    while (x >= 1) ++ans, x /= base1;
    return ans;
}

ull play(ull max)
{
    for (ll i = 0 ; i < base ; ++i)
    {
        v[i].clear();
        rem[i].clear();
    }

    for (ll i = 0 ; i < base2 ; ++i)
    {
        v2[i].clear();
        rem2[i].clear();
    }


    v[0].push_back(0);
    v2[0].push_back(0);
    for (ll i = 1 ; i < base ; ++i)
    {
        v[std::__gcd(i, base)].push_back(i);
        rem[std::__gcd(i, base)].push_back(std::__gcd(i+1, base));
    }
    for (ll i = 1 ; i < base2 ; ++i)
    {
        v2[std::__gcd(i, base2)].push_back(i);
        rem2[std::__gcd(i, base2)].push_back(std::__gcd(i+1, base2));
    }

    ans.clear();
    ll add = 0, curr = base, curr2 = base2;
    while (curr <= max && add + curr/base <= max)
    {
        ll realRes = query(add, curr);
        ll tryguessing = (realRes / (curr / base)) % base;
        ll tryguessing1 = -1;
        // std::cout << "try guessing: " << tryguessing << '\n';
        if (v[tryguessing].size() >= 2) tryguessing1 = query(add + curr/base, curr) / (curr / base);
        // std::cout << "try guessing: " << add << ' ' << curr << " (" << max / curr << ") "  << realRes << ' ' << tryguessing << ' ' << tryguessing1 << ' ' << v[tryguessing].size() << '\n';
        for (ll i = 0 ; i < v[tryguessing].size() && tryguessing1 != -1 ; ++i)
        {
            if (rem[tryguessing][i] == tryguessing1)
            {
                ans.push_back(v[tryguessing][i] - (curr != base));
                // std::cout << "push digit: " << v[tryguessing][i] - (curr != base) << '\n';
                break;
            }
        }
        if (tryguessing1 == -1)
        {
            if (v[tryguessing][0] - (curr != base) == -1) ans.push_back(base-1);
            else ans.push_back(v[tryguessing][0] - (curr != base));
            // std::cout << "push digit: " << ans.back() << '\n';
        }
        // std::cout << "here\n" << std::flush;
        add += (base - (ans.back() + (curr != base))) * (curr/base);
        curr *= base;
        curr2 *= base2;
    }

    curr /= base;
    curr *= base2;
    ll digit;
    ll realRes = query(add, curr);
    ll tryguessing = (realRes / (curr / base2)) % base2;
    ll tryguessing1 = -1;
    // std::cout << "outside\n";
    if (v2[tryguessing].size() >= 2) tryguessing1 = query(add + curr2/base2, curr) / (curr2 / base2);
    // std::cout << "curr: " << tryguessing << ' ' << tryguessing1 << '\n';
    for (ll i = 0 ; i < v2[tryguessing].size() && tryguessing1 != -1 ; ++i)
    {
        // std::cout << "rem2: " << tryguessing1 << '\n';
        if (rem2[tryguessing][i] == tryguessing1)
        {
            ans.push_back(v2[tryguessing][i] - 1);
            break;
        }
    }
    if (tryguessing1 == -1)
    {
        if (v2[tryguessing][0] - 1 == -1) ans.push_back(base2-1);
        else ans.push_back(v2[tryguessing][0] - 1);
        // std::cout << "push digit: " << ans.back() << '\n';
    }


    // std::cout << "done guessing: " << digit << "\n";
    // for (int i = 0 ; i < ans.size() ; ++i)
        // std::cout << ans[i] << ' ';
    // std::cout << '\n';
    ll res = 0;
    bool bl = 0;
    for (ll i = ans.size()-1 ; i >= 0 ; --i)
    {
        // std::cout << "in: " << i << ' ' << ans[i] << ' ' << res << '\n';
        bl |= (ans[i] != 0);
        if (bl) res *= base;
        res += ans[i];
    }

    std::cout << res << '\n';
    return res;
}

/*1 1000000000 1*/