#include <iostream>
#include <vector>
using namespace std;
vector<int> susedi[100000], children[100000];
int color[100000];
void bfs(int now, int from) {
    for (auto curr : susedi[now]) {
        if (curr != from) {
            children[now].push_back(curr);
            bfs(curr, now);
        }
    }
}
bool q1(int s, int f, int from, int c) {
    if (s == f) {
        color[s] = c;
        return true;
    }
    for (auto curr : susedi[s]) {
        if (curr != from && q1(curr, f, s, c)) {
            color[s] = c;
            return true;
        }
    }
    return false;
}
void q2(int s, int c) {
    color[s] = c;
    for (auto curr : children[s]) {
        q2(curr, c);
    }
}
int q3(int s, int f, int from) {
    if (s == f) {
        return 1;
    }
    for (auto curr : susedi[s]) {
        if (curr != from) {
            int yes = q3(curr, f, s);
            if (yes > 0) {
                if (color[curr] != color[s]) {
                    return 1 + yes;
                } else {
                    return yes;
                }
            }
        }
    }
    return 0;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        susedi[a].push_back(b);
        susedi[b].push_back(a);
    }
    bfs(0, -1);
    for (int i = 0; i < n; i++) {
        cin >> color[i];
    }
    cin >> m;
    for (int i = 0; i < m; i++) {
        int q;
        cin >> q;
        if (q == 1) {
            int a, b, c;
            cin >> a >> b >> c;
            a--;
            b--;
            if(q1(a, b, -1, c)){};
        }
        if (q == 2) {
            int a, c;
            cin >> a >> c;
            a--;
            q2(a, c);
        }
        if (q == 3) {
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            cout << q3(a, b, -1) - 1 << endl;
        }
    }
    return 0;
}
