#include<bits/stdc++.h>
using namespace std;
#define MOD 1000000007
const long long MAXM=130;
struct pr
{
    int p1,p2;
    int r;
} rr[MAXM];
typedef vector<vector<long long>> matrix;
matrix operator*(matrix& a, matrix& b)
{
    int n=a.size(),m=a[0].size(),k=b[0].size();
    matrix c(n);
    for (int q=0;q<n;q++)
    {
        c[q].resize(k);
        for (int w=0;w<k;w++)
        {
            c[q][w]=0;
            for (int e=0;e<m;e++)
            {
                c[q][w]+=a[q][e]*b[e][w];
                c[q][w]%=MOD;
            }
        }
    }
    return c;
}
matrix step(matrix& a, long long st)
{
    if (st==1)
    {
        return a;
    }
    if (st%2==1)
    {
        matrix i=step(a,st-1);
        return i*a;
    }
    matrix i=step(a,st/2);
    return i*i;
}
string k;
long long n;
int m;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>k;
    cin>>n>>m;
    for (int q=0;q<m;q++)
    {
        string ss;
        char a3;
        cin>>ss>>a3;
        rr[q].p1=ss[0]-'A';
        rr[q].p2=ss[1]-'A';
        rr[q].r=a3-'A';
    }
    matrix D(1);
    D[0].resize(m+26);
    for (int q=0;q<m+26;q++) D[0][q]=0;
    for (int q=0;q<m;q++)
    {
        for (int w=0;w<k.size()-1;w++)
        {
            if (k[w]-'A'==rr[q].p1 && k[w+1]-'A'==rr[q].p2) D[0][q]++;
        }
    }
    for (int w=0;w<k.size();w++) D[0][k[w]-'A'+m]++;
    /*for (int q=0;q<m+26;q++)
    {
        cout<<D[0][q]<<" ";
    }*/
    matrix T(m+26);
    for (int q=0;q<m+26;q++)
    {
        T[q].resize(m+26);
        for (int w=0;w<m+26;w++)
        {
            T[q][w]=0;
            if (w<m && q>=m)
            {
                T[q][w]=0;
                continue;
            }
            if (w>=m && q>=m)
            {
                if (q!=w) T[q][w]=0;
                else T[q][w]=1;
                continue;
            }
            if (w>=m && q<m)
            {
                if (rr[q].r==w-m) {T[q][w]=1;/*cout<<char(w-m+'A')<<" "<<q<<"\n";*/}
                continue;
            }
            if (w<m && q<m)
            {
                if (rr[q].p1==rr[w].p1 && rr[q].r==rr[w].p2) T[q][w]++;
                if (rr[q].r==rr[w].p1 && rr[q].p2==rr[w].p2) T[q][w]++;
                continue;
            }
        }
    }
    /*for (int q=0;q<m+26;q++)
    {
        for (int w=0;w<m+26;w++)
        {
            cout<<T[q][w]<<" ";
        }
        cout<<"\n";
    }*/
    matrix A=step(T,n);
    D=D*A;
    long long ans=0;
    /*for (int q=0;q<m;q++)
    {
        if (D[0][q]!=0)cout<<char(rr[q].p1+'A')<<" "<<char(rr[q].r+'A')<<" "<<char(rr[q].p2+'A')<<" "<<D[0][q]<<"\n";
    }*/
    for (int q=m;q<m+26;q++)
    {
        cout<<char(q-m+'A')<<" "<<D[0][q]<<"\n";
    }
}
