#include<iostream>
#include<vector>
#define endl '\n'
using namespace std;
vector<long long> v[1000000];
long long d[1000000];
bool used[1000000];
long long lca[100002][100], col[100000];

void dfs(long long vr,long long dep)
{

    d[vr]=dep;
    used[vr]=1;
    for(int i=0;i<v[vr].size();i++)
    {
        if(!used[v[vr][i]])
        {
            dfs(v[vr][i],dep+1);
            lca[v[vr][i]][0]=vr;
        }
    }
}
long long br[1000000];
void dfs2(long long vr,long long fath)
{
    if(col[vr]!=col[fath])
    {
        br[vr]=br[fath]+1;
    }
    else br[vr]=br[fath];
    used[vr]=1;

    for(int i=0;i<v[vr].size();i++)
    {
        if(!used[v[vr][i]])
        {
            dfs2(v[vr][i],vr);
        }
    }
}


long long find_lca(long long a,long long b)
{
    if(d[a]<d[b])swap(a,b);
    long long dif=d[a]-d[b], st=0;

    while(dif>0)
    {//cout<<a<<" "<<lca[a][0]<<endl;
        if(dif%2==1)
        {
            a=lca[a][st];
        }
        st++;
        dif/=2;
    }
    //cout<<a<<" "<<b<<endl;
    if(a==b)return a;

    for(int i=32;i>=0;i--)
    {
        if(lca[a][i]!=lca[b][i])
        {
            a=lca[a][i];
            b=lca[b][i];
        }
    }
    return lca[a][0];
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    long long n,i,j,q,t,a,b;

    cin>>n;

    for(i=0;i<n-1;i++)
    {
        cin>>a>>b;

        v[a].push_back(b);
        v[b].push_back(a);
    }

    dfs(1,1);

    for(i=1;i<30;i++)
    {
        for(j=1;j<=n;j++)
        {
            lca[j][i]=lca[lca[j][i-1]][i-1];
        }
    }

    for(i=1;i<=n;i++)
    {
        cin>>col[i];
        used[i]=0;
    }
    dfs2(1,1);

    cin>>q;

    for(i=1;i<=q;i++)
    {
        cin>>t>>a>>b;

        if(t==1)cin>>t;
        long long v1=find_lca(a,b);

        cout<<br[a]-br[v1]+br[b]-br[v1]<<endl;
    }



}

