//#pragma optimize("O3")
//#pragma optimize("Ofast")
#include<bits/stdc++.h>
using namespace std;

using ll = long long;
using vi = vector<int>;
using vvi = vector<vector<int>>;
using ppp = pair<vvi, vi>;
#define X first
#define Y second
const int mod = 1e9 + 7;
const int L = 26;// ** 2 == 676
const int maxLogN = ceil(log2(1e9)) + 1;
int k, n, m;
string s;
//struct rule{char a, b, c;};
//vector<rule> rules;
//vector<int> *ans1, *ans2;
//vector<vector<int>> *r1, *r2;
vector<vector<char>> r(L, vector<char>(L, -1));
vvi K[maxLogN][L][L];
vi P[maxLogN][L][L];

void transition(int iter, char a, char b)
{
    auto& prevK = K[iter - 1][a][b];
    auto& prevP = P[iter - 1][a][b];
    auto& curK = K[iter][a][b];
    auto& curP = P[iter][a][b];
    curK.assign(L, vector<int>(L, 0));
    curP.assign(L, 0);
    for(int i = 0; i < L; i++)
        for(int j = 0; j < L; j++)
            if(prevK[i][j])
    {
        auto& fndK = K[iter - 1][i][j];
        auto& fndP = P[iter - 1][i][j];
        for(int p = 0; p < L; p++)
        {
            for(int q = 0; q < L; q++)
            {
                curK[p][q] = (curK[p][q] + ll(prevK[i][j]) * fndK[p][q] % mod) % mod;
            }
            curP[p] = (curP[p] + ll(prevK[i][j]) * fndP[p] % mod) % mod;
        }
    }
    for(int i = 0; i < L; i++)
        curP[i] = (curP[i] + prevP[i]) % mod;
}

ppp transition(int iter, const vvi& cK, const vi& cP)
{

    vvi curK(L, vector<int>(L, 0));
    vi curP(L, 0);
    for(int i = 0; i < L; i++)
        for(int j = 0; j < L; j++)
            if(cK[i][j])
    {
        auto& fndK = K[iter][i][j];
        auto& fndP = P[iter][i][j];
        for(int p = 0; p < L; p++)
        {
            for(int q = 0; q < L; q++)
            {
                curK[p][q] = (curK[p][q] + ll(cK[i][j]) * fndK[p][q] % mod) % mod;
            }
            curP[p] = (curP[p] + ll(cK[i][j]) * fndP[p] % mod) % mod;
        }
    }
    for(int i = 0; i < L; i++)
        curP[i] = (curP[i] + cP[i]) % mod;
    return ppp(curK, curP);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);

    cin >>s >>n >>m;
    k = s.length();
    for(int i = 0; i < k; i++)
        s[i] -= 'A';
    //rules.resize(m);
    char a, b, c;
    for(int i = 0; i < m; i++)
    {
        cin >>a >>b >>c;
        a -= 'A';
        b -= 'A';
        c -= 'A';
        //rules[i] = {a, b, c};
        r[a][b] = c;
    }
    int logN = floor(log2(n));
    for(int i = 0; i < L; i++)
        for(int j = 0; j < L; j++)
    {
        K[0][i][j].assign(L, vector<int>(L, 0));
        P[0][i][j].assign(L, 0);
        if(~r[i][j])
        {
            P[0][i][j][r[i][j]] = 1;
            K[0][i][j][i][r[i][j]]++;
            K[0][i][j][r[i][j]][j]++;
        }
        else
        {
            K[0][i][j][i][j]++;
        }
    }
    //cout <<"logN: " <<logN <<endl;
    for(int iter = 1; iter <= logN; iter++)
        for(int i = 0; i < L; i++)
            for(int j = 0; j < L; j++)
                transition(iter, i, j);
    vvi* curK = new vvi(L, vi(L, 0));
    vi* curP = new vi(L, 0);
    for(int i = 1; i < k - 1; i++)
        (*curP)[s[i]]++;
    for(int i = 0; i < k - 1; i++)
        (*curK)[s[i]][s[i + 1]]++;
    int cnt = 0;
    while(n)
    {
        if(n & 1)
        {
            ppp p = transition(cnt, *curK, *curP);
            curK = &p.X;
            curP = &p.Y;
            //cout <<"cnt: " <<cnt <<endl;
            //cout <<"P.size(): " <<curP->size() <<endl;
            //cout <<"P: "; for(int i = 0; i < L; i++) cout <<(*curP)[i] <<" "; cout <<endl;
            //cout <<"K:\n";
            //for(int i = 0; i < L; i++)
            //{
            //    for(int j = 0; j < L; j++)
            //        cout <<(*curK)[i][j] <<" "; cout <<endl;
            //}
        }
        n >>= 1;
        cnt++;
    }
    (*curP)[s[0]] = ((*curP)[s[0]] + 1) % mod;
    (*curP)[s.back()] = ((*curP)[s.back()] + 1) % mod;
    for(int i = 0; i < L; i++)
        cout <<(char)(i + 'A') <<" " <<(*curP)[i] <<"\n";
}


/*
void old()
{
    unordered_set<char> us;
    char dic[L], rev[L];
    for(int i = 0; i < k; i++)
        s[i] -= 'A',
        us.insert(s[i]);
    rules.resize(m);
    for(int i = 0; i < m; i++)
    {
        cin >>rules[i].a >>rules[i].b >>rules[i].c;
        rules[i].a -= 'A';
        rules[i].b -= 'A';
        rules[i].c -= 'A';
        us.insert(rules[i].a);
        us.insert(rules[i].b);
        us.insert(rules[i].c);
    }
    int l = us.size();
    int pos = 0;
    for(char c : us)
    {
        dic[c] = pos;
        rev[pos++] = c;
    }
    for(int i = 0; i < k; i++)
        s[i] = dic[s[i]];
    for(const rule& rl : rules)
        r[dic[rl.a]][dic[rl.b]] = dic[rl.c];
    ans1 = new vector<int>(l, 0);
    ans2 = new vector<int>(l, 0);
    r1 = new vector<vector<int>>(l, vector<int>(l, 0));
    r2 = new vector<vector<int>>(l, vector<int>(l, 0));
    for(char c : s)
        (*ans2)[c]++;
    for(int i = 0; i < k - 1; i++)
        (*r2)[s[i]][s[i + 1]]++;
    //cout <<"ha" <<endl;
    for(int t = 0; t < n; t++)
    { //cout <<"la" <<n <<endl;
        ans1->resize(l, 0);
        r1->assign(l, vector<int>(l, 0));
        for(int i = 0; i < l; i++)
            (*ans1)[i] = (*ans2)[i];
        for(int i = 0; i < l; i++)
            for(int j = 0; j < l; j++)
        {
            if(~r[i][j])
            {
                (*r1)[i][r[i][j]] += (*r2)[i][j];
                (*r1)[r[i][j]][j] += (*r2)[i][j];
                (*r1)[i][r[i][j]] %= mod;
                (*r1)[r[i][j]][j] %= mod;
                (*ans1)[r[i][j]] += (*r2)[i][j];
                (*ans1)[r[i][j]] %= mod;
            }
            else
            {
                (*r1)[i][j] += (*r2)[i][j];
                (*r1)[i][j] %= mod;
            }
        }
        swap(ans1, ans2);
        swap(r1, r2);
    }
    ans1->assign(L, 0);
    for(int i = 0; i < l; i++)
        (*ans1)[rev[i]] = (*ans2)[i];
    for(int i = 0; i < L; i++)
    {
        cout <<(char)(i + 'A') <<" " <<(*ans1)[i] <<"\n";
    }
}*/
