#include "gcd.h"
#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
typedef unsigned long long ull;

const ull MAXN = 1000000003;

vector<ull> primes;
int sz = 0;

void init(ull from = 2, ull to = MAXN)
{
    for (ull i = from; i <= to; ++i)
    {
        bool is_prime = 1;
        for (int j = 0; j < sz; ++j)
            if (i % primes[j] == 0)
            {
                is_prime = 0;
                break;
            }

        if (is_prime)
        {
            primes.push_back(i);
            ++sz;
        }
    }
}

ull query(ull a, ull b);
ull play(ull MAX_X)
{
    primes.clear();
    sz = 0;
    ull check = query(0, MAX_X + 1);
    if (check == MAX_X + 1)
        return 0;

    ull ret = 1;
    for (ull tmp = 2; tmp <= MAX_X; ++tmp)
    {
        //cout << "** " << tmp << endl;
        if (tmp * ret > MAX_X)
            break;

        bool is_prime = 1;

        for (int j = 0; j < sz; ++j)
            if (tmp % primes[j] == 0)
            {
                is_prime = 0;
                break;
            }

        //cout << " -- " << endl;

        if (is_prime)
        {
            //cout << "prime: " << tmp << endl;
            primes.push_back(tmp);
            ++sz;

            ull num = 1;
            while (num * tmp < MAX_X)
                num *= tmp;

            ull q = query(0, num);
            //cout << num << " " << q << endl;
            ret *= q;
        }
    }

    //cout << ret << endl;
    return ret;
}

//int main()
//{
//    ios_base::sync_with_stdio(false);
//    cin.tie(NULL);
//    cout.tie(NULL);
//
//
//    return 0;
//}
