#include<bits/stdc++.h>
#define pb push_back
#define ll long long
#define ull unsigned long long
#define fr first
#define sc second
#define de(x) cout << #x << " = " << x << endl;
#define all(x) x.begin(), x.end()
using namespace std;

template<class T> using matrix = vector<vector<T>>;

int n, q, ans;
matrix<int> G;
vector<int> C;

bool dfs_path(int u, int e, int c, int p = -1){
    if(u == e){
        C[u] = c;
        return true;
    }
    for(auto v : G[u]){
        if(v == p) continue;
        if(dfs_path(v, e, c, u)){
            C[u] = c;
            return true;
        }
    }
}

bool dfs_tree(int u, int s, int c, int p = -1, bool flag = false){
    if(u == s){
        flag = true;
    }
    if(flag){
        C[u] = c;
    }
    for(auto v : G[u]){
        if(v == p) continue;
        dfs_tree(v, s, c, u, flag);
    }
}

bool dfs_query(int u, int e, int p = -1){
    if(u == e){
        return true;
    }
    for(auto v : G[u]){
        if(v == p) continue;
        if(dfs_query(v, e, u)){
            ans += (C[v] != C[u] ? 1 : 0);
            return true;
        }
    }
}

int main(){
    cin >> n;
    G = matrix<int>(n + 1);
    C = vector<int>(n + 1);
    for(int i = 0; i < n - 1; i ++){
        int u, v; cin >> u >> v;
        G[u].pb(v);
        G[v].pb(u);
    }
    for(int i = 1; i <= n; i ++){
        cin >> C[i];
    }
    cin >> q;
    for(int i = 0; i < q; i ++){
        int t; cin >> t;
        if(t == 1){
            int u, v, c; cin >> u >> v >> c;
            dfs_path(u, v, c);
        }
        if(t == 2){
            int u, c; cin >> u >> c;
            dfs_tree(1, u, c);
        }
        if(t == 3){
            int u, v; cin >> u >> v;
            ans = 0;
            dfs_query(u, v);
            cout << ans << endl;
        }
    }
}
/**
6
1 2
2 6
2 3
3 4
3 5
1 1 3 1 2 1
5
3 6 4
1 6 4 2
3 1 5
2 2 4
3 3 5

2
1
0
*/
