#include<bits/stdc++.h>
#define pb push_back
#define ll long long
#define ull unsigned long long
#define fr first
#define sc second
#define de(x) cout << #x << " = " << x << endl;
#define all(x) x.begin(), x.end()
using namespace std;

template<class T> using matrix = vector<vector<T>>;

int n, q, ans = 0;
matrix<int> G;
vector<int> col, used;

bool dfs_path(int u, int e, int c){
    used[u] = true;
    if(u == e){
        col[u] = c;
        return true;
    }
    for(auto v : G[u]){
        if(used[v]) continue;
        if(dfs_path(v, e, c)){
            col[u] = c;
            return true;
        }
    }
}

void dfs_tree(int u, int s, int c, bool flag = false){
    used[u] = true;
    if(u == s){
        flag = true;
    }
    if(flag){
        col[u] = c;
    }
    for(auto v : G[u]){
        if(used[v]) continue;
        dfs_tree(v, s, c, flag);
    }
}

bool dfs_qry(int u, int e){
    used[u] = true;
    if(u == e){
        return true;
    }
    for(auto v : G[u]){
        if(used[v]) continue;
        if(dfs_qry(v, e)){
            ans += (col[u] != col[v] ? 1 : 0);
            return true;
        }
    }
}

int main(){
    cin >> n;
    G = matrix<int>(n + 1);
    col = vector<int>(n + 1);
    for(int i = 0; i < n - 1; i ++){
        int u, v; cin >> u >> v;
        G[u].pb(v);
        G[v].pb(u);
    }
    for(int i = 1; i <= n; i ++){
        cin >> col[i];
    }
    cin >> q;
    for(int i = 0; i < q; i ++){
        int t; cin >> t;
        used = vector<int>(n + 1, 0);
        if(t == 1){
            int u, v, c; cin >> u >> v >> c;
            dfs_path(u, v, c);
        }
        if(t == 2){
            int u, c; cin >> u >> c;
            dfs_tree(1, u, c);
        }
        if(t == 3){
            int u, v; cin >> u >> v;
            ans = 0;
            dfs_qry(u, v);
            cout << ans << endl;
        }
    }
}
