#include<bits/stdc++.h>
#define pb push_back
#define ll long long
#define ull unsigned long long
#define fr first
#define sc second
#define de(x) cout << #x << " = " << x << endl;
#define all(x) x.begin(), x.end()
using namespace std;

template<class T> using matrix = vector<vector<T>>;

int n, q;
matrix<int> G, subtrees, ptr;
vector<int> col;

void dfs1(int u = 1, int p = 1){
    subtrees[u].pb(u);
    for(auto v : G[u]){
        if(v == p) continue;
        dfs1(v, u);
        for(auto x : subtrees[v]){
            subtrees[u].pb(x);
        }
    }
}

void dfs2(int u, int c, int p = -1){
    ptr[c][u] = p;
    for(auto v : G[u]){
        if(v == p) continue;
        dfs2(v, c, u);
    }
}

int main(){
    cin >> n;
    subtrees = G = matrix<int>(n + 1);
    ptr = matrix<int>(n + 1, vector<int>(n + 1));
    col = vector<int>(n + 1);
    for(int i = 0; i < n - 1; i ++){
        int u, v; cin >> u >> v;
        G[u].pb(v);
        G[v].pb(u);
    }
    for(int i = 1; i <= n; i ++){
        cin >> col[i];
    }
    dfs1();
    for(int u = 1; u <= n; u ++){
        dfs2(u, u);
    }
    cin >> q;
    for(int i = 0; i < q; i ++){
        int t; cin >> t;
        if(t == 1){
            int u, v, c; cin >> u >> v >> c;
            while(1){
                col[u] = c;
                if(ptr[v][u] == -1){
                    break;
                }
                u = ptr[v][u];
            }
        }
        if(t == 2){
            int u, c; cin >> u >> c;
            for(auto x : subtrees[u]){
                col[x] = c;
            }
        }
        if(t == 3){
            int u, v, ans = 0; cin >> u >> v;
            while(1){
                if(ptr[v][u] == -1){
                    break;
                }
                if(col[u] != col[ptr[v][u]]){
                    ++ ans;
                }
                u = ptr[v][u];
            }
            cout << ans << endl;
        }
    }
}
/**
6
1 2
2 6
2 3
3 4
3 5
1 1 3 1 2 1
5
3 6 4
1 6 4 2
3 1 5
2 2 4
3 3 5

2
1
0
*/
