#include<bits/stdc++.h>
#define pb push_back
#define ll long long
#define ull unsigned long long
#define fr first
#define sc second
#define de(x) cout << #x << " = " << x << endl;
#define all(x) x.begin(), x.end()
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const ll MOD = 1e9 + 7;
const int MAXN = 1e6 + 6;

string t;
set<int> S;
int n, m;
map<char, ll> ch_to_in, in_to_ch, freq;
int uT[256][256];
int fT[20][20], hfT[20][20];
ll dp[MAXN][15][15];

int main(){
    cin >> t >> n >> m;
    for(auto x : t) S.insert(x);
    for(int i = 0; i < m; i ++){
        string a; char b; cin >> a >> b;
        S.insert(a[0]);
        S.insert(a[1]);
        S.insert(b);
        uT[a[0]][a[1]] = b;
    }
    int T = 1;
    for(auto z : S){
        ch_to_in[z] = T;
        in_to_ch[T] = z;
        ++ T;
    }
    for(char Z1 = 'A'; Z1 <= 'Z'; Z1 ++) for(char Z2 = 'A'; Z2 <= 'Z'; Z2 ++){
        if(uT[Z1][Z2]){
            int z1 = ch_to_in[Z1];
            int z2 = ch_to_in[Z2];
            fT[z1][z2] = ch_to_in[uT[Z1][Z2]];
            hfT[z1][z2] = true;
        }
    }
    for(int i = 0; i < t.size() - 1; i ++){
        int z1 = ch_to_in[t[i + 0]];
        int z2 = ch_to_in[t[i + 1]];
        dp[0][z1][z2] ++;
    }
    for(int iter = 1; iter <= n; iter ++){
        for(int i = 0; i < 15; i ++) for(int j = 0; j < 15; j ++){
            if(hfT[i][j]){
                int k = fT[i][j];
                dp[iter][i][k] = (dp[iter][i][k] + dp[iter - 1][i][j]) % MOD;
                dp[iter][k][j] = (dp[iter][k][j] + dp[iter - 1][i][j]) % MOD;
            }
        }
    }
    for(int i = 0; i < 15; i ++){
        for(int j = 0; j < 15; j ++){
            freq[in_to_ch[i]] = (freq[in_to_ch[i]] + dp[n][i][j]) % MOD;
            freq[in_to_ch[j]] = (freq[in_to_ch[j]] + dp[n][i][j]) % MOD;
        }
    }
    freq[t[0]] = (freq[t[0]] + 1) % MOD;
    freq[t.back()] = (freq[t.back()] + 1) % MOD;
    for(char z = 'A'; z <= 'Z'; z ++){
        cout << z << " " << (freq[z] * 500000004) % MOD << endl;
    }
}
/**
NNCB
4 16
CH B
HH N
CB H
NH C
HB C
HC B
HN C
NN C
BH H
NC B
NB B
BN B
BB N
BC B
CC N
CN C

*/

