#include<bits/stdc++.h>
using namespace std;

const int lmax=26,mod=1e9+7;

long long given[676][676],paths[676][676];

long long help[676][676];

void mult_paths()
{
    memset(help,0,sizeof(help));

    for(int k=0;k<676;k++)
    {
        vector<int> valid_i={};
        vector<int> valid_j={};

        for(int i=0;i<676;i++)
            if(paths[i][k])valid_i.push_back(i);

        for(int j=0;j<676;j++)
            if(paths[k][j])valid_j.push_back(j);

        for(auto i:valid_i)
            for(auto j:valid_j)
                help[i][j]=(help[i][j]+paths[i][k]*paths[k][j])%mod;
    }

    for(int i=0;i<676;i++)
        for(int j=0;j<676;j++)
            paths[i][j]=help[i][j];
}

void mult_given()
{
    memset(help,0,sizeof(help));

    for(int k=0;k<676;k++)
    {
        vector<int> valid_i={};
        vector<int> valid_j={};

        for(int i=0;i<676;i++)
            if(given[i][k])valid_i.push_back(i);

        for(int j=0;j<676;j++)
            if(paths[k][j])valid_j.push_back(j);

        for(auto i:valid_i)
            for(auto j:valid_j)
                help[i][j]=(help[i][j]+given[i][k]*paths[k][j])%mod;
    }

    /*
    for(int i=0;i<676;i++)
        for(int j=0;j<676;j++)
            for(int k=0;k<676;k++)
                help[i][j]=(help[i][j]+given[i][k]*paths[k][j])%mod;
    */

    for(int i=0;i<676;i++)
        for(int j=0;j<676;j++)
            given[i][j]=help[i][j];
}

int outp[26];

int hsh(char a,char b)
{
    return 26*(a-'A')+(b-'A');
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();

    string inp;

    cin>>inp;

    for(int i=1;i<inp.size();i++)
    {
        int h=hsh(inp[i-1],inp[i]);

        given[h][h]++;
    }

    outp[inp.back()-'A']++;

    int n,m;

    cin>>n>>m;

    for(int i=1;i<=m;i++)
    {
        char c1,c2,c3;

        cin>>c1>>c2>>c3;

        int from=hsh(c1,c2);
        int to1=hsh(c1,c3);
        int to2=hsh(c3,c2);

        paths[from][to1]++;
        paths[from][to2]++;
    }

    while(n)
    {
        if(n%2)mult_given();

        mult_paths();

        n=n/2;
    }

    for(int c1=0;c1<26;c1++)
        for(int c2=0;c2<26;c2++)
        {
            long long cur=0;

            for(int j=0;j<26*26;j++)
                cur=(cur+given[j][c1*26+c2])%mod;

            outp[c1]=(outp[c1]+cur)%mod;
        }

    for(int i=0;i<26;i++)
        cout<<char(i+'A')<<" "<<outp[i]<<endl;

    return 0;
}

/*
NNCB
4 16
CH B
HH N
CB H
NH C
HB C
HC B
HN C
NN C
BH H
NC B
NB B
BN B
BB N
BC B
CC N
CN C

A 0
B 23
C 10
D 0
E 0
F 0
G 0
H 5
I 0
J 0
K 0
L 0
M 0
N 11
O 0
...
Z 0

*/