#include <bits/stdc++.h>
using namespace std;

int n;
const int MAXN = 100001;
struct Tel{
    int st, otg;
};
vector<Tel> tree[MAXN];
int color[MAXN], Otg[MAXN];
int findd[MAXN];
int b[2*MAXN] , posb = 0;
bool fl[MAXN];
int table[17][MAXN];
int rod[MAXN];

void dfs(int k) {
    fl[k] = 1;
    b[++posb] = k;
    findd[k] = posb;
    for(int i=0;i<tree[k].size();i++) {
        int to = tree[k][i].st;
        if(fl[to] == 0) {
            rod[to] = k;
            dfs(to);
            b[++posb] = k;
            if(color[k] != color[to]) tree[k][i].otg = Otg[to]+1;
            else  tree[k][i].otg = Otg[to];
            Otg[k] = max(Otg[k], tree[k][i].otg);
        }
    }
}

int FindAnses(int p, int q) {
    int anses;
    int ll = findd[p], rr = findd[q];
    if(ll > rr) swap(ll, rr);
    int raz = rr-ll+1;
    int l = log2(raz);
    if(1<<l > raz) l--;
    //cout<<ll<<" "<<rr<<" "<<l<<endl;
    anses = min(table[l][ll], table[l][rr-(1<<l)+1]);
    //cout<<p<<" "<<q<<" - "<<anses<<endl;
    return anses;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    int i, j;
    for(i=1;i<n;i++) {
        int p, q;
        cin>>p>>q;
        tree[p].push_back({q, 0});
        tree[q].push_back({p, 0});
    }
    for(i=1;i<=n;i++) cin>>color[i];
    //cout<<endl;
    dfs(1);
    //for(i=1;i<=n;i++) cout<<Otg[i]<<" "<<endl;
   /* for(i=1;i<=n;i++) {
        for(j=0;j<tree[i].size();j++) cout<<tree[i][j].otg<<" ";
        cout<<endl;
    }*/

    //for(i=1;i<=posb;i++) cout<<b[i]<<" ";  cout<<endl;
    int m = posb;
    for(i=0;i<=m;i++) table[0][i] = b[i];
    int l = log2(m);
    if(1<<l > m) l--;
    for(i=1;i<=l;i++) {
        for(j=1;j<=m;j++) {
            //cout<<j<<" "<<j+(1<<(i-1))<<endl;
            table[i][j] = table[i-1][j];
            if(j+(1<<(i-1)) <= m)
                table[i][j] = min(table[i][j], table[i-1][j+(1<<(i-1))]);
        }
    }
    /*for(i=0;i<=l;i++) {
        for(j=1;j<=m;j++) cout<<table[i][j]<<" ";
        cout<<endl;
    }*/
    int q;
    cin>>q;
    for(i=1;i<=q;i++) {
        int z, p, q;
        cin>>z>>p>>q;
        if(z == 3) {
            int anses = FindAnses(p, q);
            int ans = 0;
            int tek = p;
            while(tek != anses) {
                if(color[tek] != color[rod[tek]]) ans++;
                tek = rod[tek];
            }
            tek = q;
            while(tek != anses) {
                if(color[tek] != color[rod[tek]]) ans++;
                tek = rod[tek];
            }
            cout<<ans<<endl;
        }
    }

    return 0;
}
/*
10
1 2
1 3
2 4
2 5
2 6
5 8
8 9
6 10
3 7
1 1 3 3 4 2 4 1 2 2
*/
