#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e9+9, maxm = 128, maxk = 1e5+5, maxl = 26, mod = 1e9+7;
int n, m, k;
string s;
struct rule{
    char a, b, c;
};
rule r [maxm];
map <pair <char, char>, int> rules;
long long dp1 [maxm][maxm][32], dp2 [maxm][maxl][32];
long long dp3 [maxm][2], dp4 [maxl][2];

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> s;
    k = s.size ();
    cin >> n >> m;
    for (int i = 0; i < m; i ++){
        cin >> r [i].a >> r [i].b >> r [i].c;
        rules [{r [i].a, r [i].b}] = i;
    }
    for (int i = 0; i < m; i ++){
        if (rules.count ({r [i].a, r [i].c})) dp1 [i][rules [{r [i].a, r [i].c}]][0] ++;
        if (rules.count ({r [i].c, r [i].b})) dp1 [i][rules [{r [i].c, r [i].b}]][0] ++;
        dp2 [i][r [i].c - 'A'][0] ++;
    }
    for (int x = 1; x <= 30; x ++){
        for (int i = 0; i < m; i ++){
            for (int j = 0; j < maxl; j ++) dp2 [i][j][x] = dp2 [i][j][x - 1];
            for (int j = 0; j < m; j ++){
                for (int h = 0; h < maxl; h ++){
                    dp2 [i][h][x] += dp1 [i][j][x - 1] * dp2 [j][h][x - 1];
                    dp2 [i][h][x] %= mod;
                }
                for (int h = 0; h < m; h ++){
                    dp1 [i][h][x] += dp1 [i][j][x - 1] * dp1 [j][h][x - 1];
                    dp1 [i][h][x] %= mod;
                }
            }
        }
    }
    for (int i = 0; i < k; i ++) dp4 [s [i] - 'A'][0] ++;
    for (int i = 1; i < k; i ++){
        if (rules.count ({s [i - 1], s [i]})) dp3 [rules [{s [i - 1], s [i]}]][0] ++;
    }
    for (int x = 0; x <= 30; x ++){
        if (n & (1 << x)){
            for (int i = 0; i < maxl; i ++) dp4 [i][1] = dp4 [i][0];
            for (int i = 0; i < m; i ++){
                for (int j = 0; j < maxl; j ++){
                    dp4 [j][1] += dp3 [i][0] * dp2 [i][j][x];
                    dp4 [j][1] %= mod;
                }
                for (int j = 0; j < m; j ++){
                    dp3 [j][1] += dp3 [i][0] * dp1 [i][j][x];
                    dp3 [j][1] %= mod;
                }
            }
            for (int i = 0; i < m; i ++){
                dp3 [i][0] = dp3 [i][1];
                dp3 [i][1] = 0;
            }
            for (int i = 0; i < maxl; i ++){
                dp4 [i][0] = dp4 [i][1];
                dp4 [i][1] = 0;
            }
        }
    }
    for (int i = 0; i < maxl; i ++){
        cout << char (i + 'A') << ' ' << dp4 [i][0] << '\n';
    }

}
