#include<iostream>
#define M 128
#define N 128+26
#define LTRS 26
using namespace std;

struct matrix{
    int n;
    int matrix[200][200];
};

int mutations[1000];
int mIds[1000];

struct mutation{
    char a, b, c;
};

mutation muts[1000];

matrix mult(matrix a, matrix b){
    matrix result;
    int n=a.n;
    result.n=n;
    for(int y=0;y<n;y++){
        for(int x=0;x<n;x++){
            result.matrix[x][y]=0;
            for(int k=0;k<n;k++){
                result.matrix[x][y]+=a.matrix[k][y]*b.matrix[x][k];
            }
        }
    }
    return result;
}

matrix susedi, paths;

int letters[26];
int main(){
    for(int i=0;i<1000;i++){
        mIds[i]=-1;
    }
    string init;
    cin>>init;
    int n,m;
    cin>>n>>m;
    susedi.n=N;
    for(int i=0;i<m;i++){
        char a,b,c;
        cin>>a>>b>>c;
        muts[i].a=a;
        muts[i].b=b;
        muts[i].c=c;
        //cout<<"change: "<<a<<b<<" "<<c<<endl;
        int from = (a-'A')*LTRS+(b-'A');
        mutations[i]=from;
        mIds[from]=i;
    }
    for(int i=0;i<m;i++){
        char a,b,c;
        //cin>>a>>b>>c;
        //cout<<"change: "<<a<<b<<" "<<c<<endl;
        a=muts[i].a;
        b=muts[i].b;
        c=muts[i].c;
        int from = (a-'A')*LTRS+(b-'A');
        int to1 = (a-'A')*LTRS+(c-'A');
        int to2 = (c-'A')*LTRS+(b-'A');
        int letter = M+(c-'A');
        if(mIds[to1]!=-1){
            susedi.matrix[i][mIds[to1]]++;
        }
        if(mIds[to1]!=-1){
            susedi.matrix[i][mIds[to2]]++;
        }

        susedi.matrix[i][letter]++;
    }
    for(int i=0;i<LTRS;i++){
        int letter = M+i;
        susedi.matrix[letter][letter]=1;
    }
    paths=susedi;
    for(int i=1;i<n;i++){
        paths=mult(paths,susedi);
    }
    for(int i=0;i<init.size();i++){
        letters[init[i]-'A']++;
    }

    for(int i=0;i<init.size()-1;i++){
        int from = (init[i]-'A')*LTRS+(init[i+1]-'A');
        if(mIds[from]!=-1){
                //cout<<"aaaa";
            for(int j=0;j<LTRS;j++){
                letters[j]+=paths.matrix[mIds[from]][M+j];
            }
        }
    }

    for(int i=0;i<26;i++){
        cout<<(char)('A'+i)<<" "<<letters[i]<<endl;
    }

    return 0;
}
