#include<iostream>
#define M 128
#define N 128+26
#define LTRS 26

#define MOD 1000000007

using namespace std;

struct matrix{
    long long n;
    long long matrix[200][200];
};

long long mutations[1000];
long long mIds[1000];

struct mutation{
    char a, b, c;
};

mutation muts[1000];

matrix mult(matrix a, matrix b){
    matrix result;
    long long n=a.n;
    result.n=n;
    for(long long y=0;y<n;y++){
        for(long long x=0;x<n;x++){
            result.matrix[x][y]=0;
            for(long long k=0;k<n;k++){
                result.matrix[x][y]+=(a.matrix[k][y]*b.matrix[x][k])%MOD;
                result.matrix[x][y]%=MOD;
            }
        }
    }
    return result;
}

matrix susedi, paths;

long long letters[26];
int main(){
    for(long long i=0;i<1000;i++){
        mIds[i]=-1;
    }
    string init;
    cin>>init;
    long long n,m;
    cin>>n>>m;
    susedi.n=N;
    for(long long i=0;i<m;i++){
        char a,b,c;
        cin>>a>>b>>c;
        muts[i].a=a;
        muts[i].b=b;
        muts[i].c=c;
        //cout<<"change: "<<a<<b<<" "<<c<<endl;
        long long from = (a-'A')*LTRS+(b-'A');
        mutations[i]=from;
        mIds[from]=i;
    }
    for(long long i=0;i<m;i++){
        char a,b,c;
        //cin>>a>>b>>c;
        //cout<<"change: "<<a<<b<<" "<<c<<endl;
        a=muts[i].a;
        b=muts[i].b;
        c=muts[i].c;
        long long from = (a-'A')*LTRS+(b-'A');
        long long to1 = (a-'A')*LTRS+(c-'A');
        long long to2 = (c-'A')*LTRS+(b-'A');
        long long letter = M+(c-'A');
        if(mIds[to1]!=-1){
            susedi.matrix[i][mIds[to1]]++;
        }
        if(mIds[to1]!=-1){
            susedi.matrix[i][mIds[to2]]++;
        }

        susedi.matrix[i][letter]++;
    }
    for(long long i=0;i<LTRS;i++){
        long long letter = M+i;
        susedi.matrix[letter][letter]=1;
    }
    paths=susedi;
    for(long long i=1;i<n;i++){
        paths=mult(paths,susedi);
    }
    for(long long i=0;i<init.size();i++){
        letters[init[i]-'A']++;
    }

    for(long long i=0;i<init.size()-1;i++){
        long long from = (init[i]-'A')*LTRS+(init[i+1]-'A');
        if(mIds[from]!=-1){
                //cout<<"aaaa";
            for(long long j=0;j<LTRS;j++){
                letters[j]+=paths.matrix[mIds[from]][M+j];
                letters[j]%=MOD;
            }
        }
    }

    for(long long i=0;i<26;i++){
        cout<<(char)('A'+i)<<" "<<letters[i]<<endl;
    }

    return 0;
}
