#include <bits/stdc++.h>
using namespace std;
const int MAX=100000;
struct st{
    int v, rev;
};
int colors[MAX], parent[MAX];
int main(){
ios_base::sync_with_stdio(false);
cin.tie(0);
int n;
cin>>n;
vector <int> nbrs[n];
for(int i=0;i<n-1;i++){
    int a, b;
    cin>>a>>b;
    a--;
    b--;
    nbrs[a].push_back(b);
    nbrs[b].push_back(a);
}
for(int i=0;i<n;i++){
    cin>>colors[i];
}
queue <st> qu;
qu.push({0, 0});
fill(parent, parent+n, -1);
while(!qu.empty()){
    int curr=qu.front().v;
    parent[curr]=qu.front().rev;
    qu.pop();
    for(int i=0;i<nbrs[curr].size();i++){
        if(parent[nbrs[curr][i]]==-1){
            qu.push({nbrs[curr][i], curr});
        }
    }
}
int q;
cin>>q;
for(int j=0;j<q;j++){
    int input;
    cin>>input;
    if(input==1){
        int u, v, c;
        cin>>u>>v>>c;
        u--;
        v--;
        queue <st> q;
        q.push({u, u});
        int rev[n];
        fill(rev, rev+n, -1);
        while(!q.empty()){
            int curr=q.front().v;
            rev[curr]=q.front().rev;
            q.pop();
            if(curr==v){
                break;
            }
            for(int i=0;i<nbrs[curr].size();i++){
                if(rev[nbrs[curr][i]]==-1){
                    q.push({nbrs[curr][i], curr});
                }
            }
        }
        int curr=v;
        while(curr!=u){
            colors[curr]=c;
            curr=rev[curr];
        }
        colors[curr]=c;
    }
    if(input==2){
        int u, c;
        cin>>u>>c;
        u--;
        queue <int> q;
        q.push(u);
        bool taken[n];
        fill(taken, taken+n, false);
        while(!q.empty()){
            int curr=q.front();
            q.pop();
            colors[curr]=c;
            taken[curr]=true;
            for(int i=0;i<nbrs[curr].size();i++){
                if(!taken[nbrs[curr][i]] and nbrs[curr][i]!=parent[u]){
                    q.push(nbrs[curr][i]);
                }
            }
        }
    }
    if(input==3){
        int u, v;
        cin>>u>>v;
        u--;
        v--;
        queue <st> q;
        q.push({u, u});
        int rev[n];
        fill(rev, rev+n, -1);
        while(!q.empty()){
            int curr=q.front().v;
            rev[curr]=q.front().rev;
            q.pop();
            if(curr==v){
                break;
            }
            for(int i=0;i<nbrs[curr].size();i++){
                if(rev[nbrs[curr][i]]==-1){
                    q.push({nbrs[curr][i], curr});
                }
            }
        }
        int ans=0;
        if(u==v){
            cout<<0<<"\n";
            continue;
        }
        int old=v, curr=rev[old];
        while(old!=u){
            if(colors[old]!=colors[curr]){
                ans++;
            }
            old=curr;
            curr=rev[old];
        }
        cout<<ans<<"\n";
    }
}
return 0;
}
