#include <iostream>
#include <vector>
#define ll long long
#define endl "\n"
using namespace std;

const ll maxn=1e5;
ll color[maxn],q,n;
vector<ll> sysedi[maxn];

bool update(ll curr, ll to, ll c, ll previ){
    for(ll i=0;i<sysedi[curr].size();i++){
        if(sysedi[curr][i]==previ){
            continue;
        }
        if(sysedi[curr][i]==to){
            color[to]=c;
            color[curr]=c;
            return true;
        }
        if(update(sysedi[curr][i],to,c,curr)){
            color[curr]=c;
            return true;
        }
    }
    return false;
}

long long answer(ll curr, ll to, ll previ){
    if(curr==to){
        return 0;
    }
    for(ll i=0;i<sysedi[curr].size();i++){
        if(sysedi[curr][i]==previ){
            continue;
        }
        if(sysedi[curr][i]==to){
            if(color[curr]!=color[to]){
                return 1;
            }
            return 0;
        }
        ll an=answer(sysedi[curr][i],to,curr);
        if(an!=-1){
            if(color[curr]!=color[sysedi[curr][i]]){
                return an+1;
            }else{
                return an;
            }
        }
    }
    return -1;
}

int main(){
ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);
    ll from,to,c,u,v,typ;
    cin >> n;
    for(ll i=0;i<n-1;i++){
        cin >> v >> u;
        sysedi[v-1].push_back(u-1);
        sysedi[u-1].push_back(v-1);
    }
    for(ll i=0;i<n;i++){
        cin >> color[i];
    }
    cin >> q;
    for(ll i=0;i<q;i++){
        /*for(ll j=0;j<n;j++){
            cout << color[j] << " ";
        }
        cout << endl;
        for(ll j=0;j<n;j++){
            cout << j << " ";
        }
        cout << endl;*/
        cin >> typ;
        if(typ==1){
            cin >> from >> to >> c;
            update(from-1,to-1,c,from-1);
        }
        if(typ==2){
            cin >> from >> c;
            update(from-1,0,c,from-1);
        }
        if(typ==3){
            cin >> from >> to;
            cout << answer(from-1,to-1,from-1) << endl;
        }
    }

return 0;
}


