#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int maxn = 500000;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int n,q;
vector<int>v[maxn];
int color[maxn];
int used[maxn];
int parent[maxn];
int tc;
int from,to;
int ans = 0;
void dfs_make_parent( int w )
{
    used[w] = 1;
    int sz = v[w].size();
    for( int i = 0; i < sz; i ++ )
    {
        int nb = v[w][i];
        if( used[nb] == 0 )
        {
            parent[nb] = w;
            dfs_make_parent(nb);
        }
    }
}
int dfs_1( int w )
{
    used[w] = 1;
    if( w == to )
    {
        color[w] = tc;
        return 1;
    }
    int sz = v[w].size();
    int big_lamp = 0;
    for( int i = 0; i < sz; i ++ )
    {
        int nb = v[w][i];
        if( used[nb] == 0 )
        {
            int lamp = dfs_1(nb);
            if( lamp == 1 )
            {
                color[w] = tc;
                big_lamp = 1;
            }
        }
    }
    return big_lamp;
}
void dfs_2( int w )
{
    color[w] = tc;
    int sz = v[w].size();
    for( int i = 0; i < sz; i ++ )
    {
        int nb = v[w][i];
        if( nb == parent[w] ) continue;
        dfs_2(nb);
    }
}
int dfs_3( int w )
{
    used[w] = 1;
    if( w == to ) return 1;
    int sz = v[w].size();
    int big_lamp = 0;
    for( int i = 0; i < sz; i ++ )
    {
        int nb = v[w][i];
        if( used[nb] == 0 )
        {
            int lamp = dfs_3(nb);
            if( lamp == 1 )
            {
                big_lamp = 1;
                if( color[w] != color[nb] ) ans += 1;
            }
        }
    }
    return big_lamp;
}
void read()
{
    cin >> n;
    for( int i = 1; i < n; i ++ )
    {
        int x,y;
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    for( int i = 1; i <= n; i ++ )
    {
        cin >> color[i];
    }
    parent[1] = 1;
    dfs_make_parent(1);
    cin >> q;
    for( int i = 1; i <= q; i ++ )
    {
       int t;
       cin >> t;
       memset(used,0,sizeof(used));
       if( t == 3 )
       {
           cin >> from >> to;
           ans = 0;
           dfs_3(from);
           cout << ans << endl;
           continue;
       }
       else if( t == 2 )
       {
           cin >> from >> tc;
           dfs_2(from);
           continue;
       }
       else if( t == 1 )
       {
           cin >> from >> to >> tc;
           dfs_1(from);
           continue;
       }
    }
}
int main()
{
    speed();
    read();
    return 0;
}
