#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const long long maxn = 200002;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
long long n,q;
vector<long long>v[maxn];
long long idx[maxn];
long long cnt_ch[maxn];
long long used[maxn];
long long color[maxn];
long long par[maxn];
long long tin[maxn];
long long lvl[maxn];
long long tree[maxn*4];
long long path[maxn*4];
long long lvl_path[maxn*4];
long long timer = 1;
long long cnt_idx = 2;
long long parent[maxn];
pair<long long,long long>lazy[maxn*4];
pair<long long,long long>lazy_2[maxn*4];
void push_lazy_2( long long i, long long l, long long r)
{
    if( l == r ) return;
    if( lazy_2[i*2].second < lazy_2[i].second ) lazy_2[i*2] = lazy_2[i];
    if( lazy_2[i*2+1].second < lazy_2[i].second ) lazy_2[i*2+1] = lazy_2[i];
}
void update_2(long long i, long long l, long long r, long long ql, long long qr, long long x,long long y)
{
    if( l == ql && r == qr )
    {
        lazy_2[i].first = x;
        lazy_2[i].second = y;
        push_lazy_2(i,l,r);
        return;
    }
    long long m = ( l + r ) / 2;
    if( qr <= m ) update_2(i*2,l,m,ql,qr,x,y);
    else if( ql > m ) update_2(i*2+1,m+1,r,ql,qr,x,y);
    else
    {
        update_2(i*2,l,m,ql,m,x,y);
        update_2(i*2+1,m+1,r,m+1,qr,x,y);
    }
    push_lazy_2(i*2,l,m);
    push_lazy_2(i*2+1,m+1,r);
    return;
}
long long query_color( long long i, long long l, long long r, long long pos )
{
    push_lazy_2(i,l,r);
    if( l == r )
    {
        //cout << pos << " " << lazy[i].first << " " << lazy[i].second << endl;
        if( lazy_2[i].second == 0 ) return color[l];
        return lazy_2[i].first;
    }
    long long m = ( l + r ) / 2;
    if( pos <= m ) return query_color(i*2,l,m,pos);
    else return query_color(i*2+1,m+1,r,pos);
}
void push_lazy( long long i, long long l, long long r )
{
    if( l == r ) return;
    if( lazy[i*2].second < lazy[i].second ) lazy[i*2] = lazy[i];
    if( lazy[i*2+1].second < lazy[i].second ) lazy[i*2+1] = lazy[i];
}
void update(long long i, long long l, long long r, long long ql, long long qr, long long x, long long y )
{
    if( l == ql && r == qr )
    {
        lazy[i].first = x;
        lazy[i].second = y;
        push_lazy(i,l,r);
        return;
    }
    long long m = ( l + r ) / 2;
    if( qr <= m ) update(i*2,l,m,ql,qr,x,y);
    else if( ql > m ) update(i*2+1,m+1,r,ql,qr,x,y);
    else
    {
        update(i*2,l,m,ql,m,x,y);
        update(i*2+1,m+1,r,m+1,qr,x,y);
    }
    push_lazy(i*2,l,m);
    push_lazy(i*2+1,m+1,r);
    return;
}
long long query_par(long long i, long long l, long long r, long long pos )
{
    push_lazy(i,l,r);
    if( l == r )
    {
        //cout << pos << " " << lazy[i].first << " " << lazy[i].second << endl;
        if( lazy[i].second == 0 ) return par[l];
        return lazy[i].first;
    }
    long long m = ( l + r ) / 2;
    if( pos <= m ) return query_par(i*2,l,m,pos);
    else return query_par(i*2+1,m+1,r,pos);
}
void make_tree( long long i, long long l, long long r )
{
    if( l == r )
    {
        tree[i] = l;
        return;
    }
    long long m = ( l + r ) / 2;
    make_tree(i*2,l,m);
    make_tree(i*2+1,m+1,r);
    if( lvl_path[tree[i*2]] < lvl_path[tree[i*2+1]] ) tree[i] = tree[i*2];
    else tree[i] = tree[i*2+1];
    return;
}
long long query( long long i, long long l, long long r, long long ql, long long qr )
{
    if( l == ql && r == qr )
    {
        return tree[i];
    }
    long long m = ( l + r ) / 2;
    if( qr <= m ) return query(i*2,l,m,ql,qr);
    else if( ql > m ) return query(i*2+1,m+1,r,ql,qr);
    else
    {
        long long x = query(i*2,l,m,ql,m);
        long long y = query(i*2+1,m+1,r,m+1,qr);
        if( lvl_path[x] < lvl_path[y] ) return x;
        else return y;
    }
}
void dfs( long long w )
{
    cnt_ch[idx[w]] = 1;
    used[w] = 1;
    tin[w] = timer;
    path[timer] = w;
    lvl_path[timer] = lvl[w];
    timer += 1;
    long long sz = v[w].size();
    for( long long i = 0; i < sz; i++ )
    {
        long long nb = v[w][i];
        if( used[nb] == 0 )
        {
            lvl[nb] = lvl[w] + 1;
            idx[nb] = cnt_idx;
            cnt_ch[idx[w]] += 1;
            cnt_idx += 1;
            parent[nb] = w;
            if( color[w] == color[nb] ) par[idx[nb]] = par[idx[w]];
            else par[idx[nb]] = par[idx[w]] + 1;
            dfs(nb);
            path[timer] = w;
            lvl_path[timer] = lvl[w];
            timer += 1;
        }
    }
    return;
}
void init_lca()
{
    idx[1] = 1;
    lvl[1] = 1;
    parent[1] = 1;
    dfs(1);
    make_tree(1,1,timer-1);
}
void read()
{
    cin >> n;
    for( long long i = 1; i < n; i ++ )
    {
        long long x,y;
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    for( long long i = 1; i <= n; i ++ )
    {
        cin >> color[i];
    }
    init_lca();
    cin >> q;
    for( long long i = 1; i <= q; i ++ )
    {
        long long t;
        cin >> t;
        if( t == 2 )
        {
            long long x,tc;
            cin >> x >> tc;
            long long upd;
            long long from = idx[x];
            long long to = from + cnt_ch[from] - 1;
            if( from == 1 )
            {
                //cout << 222 << endl;
                upd = 0;
                update(1,1,n,1,n,upd,i);
            }
            else
            {
                long long color_parent = query_color(1,1,n,parent[x]);
                if( color_parent == tc )
                {
                    upd = query_par(1,1,n,idx[parent[x]]);
                    update(1,1,n,from,to,upd,i);
                }
                else
                {
                    upd = query_par(1,1,n,idx[parent[x]]) + 1;
                    update(1,1,n,from,to,upd,i);
                }
            }
        }
        else
        {
            long long x,y;
            cin >> x >> y;
            long long lca = path[query( 1, 1, timer-1, min(tin[x],tin[y]) , max(tin[x],tin[y]) )];
            //cout << lca << endl;
            long long from = idx[x];
            long long to = idx[y];
            long long mid = idx[lca];
            long long from_par = query_par(1,1,n,from);
            long long to_par = query_par(1,1,n,to);
            long long mid_par = query_par(1,1,n,mid);
            //cout << from_par << " " << to_par << " " << mid_par << endl;
            long long ans = ( from_par - mid_par ) + ( to_par - mid_par );
            cout << ans << endl;
        }
    }
}
int main()
{
	speed();
	read();
    return 0;
}
