#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e5;
int n, c[maxn], q, p[maxn], cnt = 1, used[maxn], a[2*maxn], l[2*maxn], t[8*maxn];
bool used1[maxn];
vector <int> v[maxn];

void read()
{
    /*ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);*/

    cin >> n ;
    int i, x, y;
    for (i=1; i<n; ++i)
    {
        cin >> x >> y ;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    for (i=1; i<=n; ++i)
    {
        cin >> c[i] ;
    }
}

void DFS(int ver, int last, int lvl)
{
    //cout << ver << endl;
    used[ver] = cnt;
    l[cnt] = lvl;
    a[cnt] = ver;
    ++ cnt;
    p[ver] = last;

    int i, len = v[ver].size();
    for (i=0; i<len; ++i)
    {
        if (used[v[ver][i]] == 0)
        {
            DFS(v[ver][i], ver, lvl+1);
            l[cnt] = lvl;
            a[cnt] = ver;
            ++ cnt;
        }
    }
}

void make_tree(int i, int ll, int r)
{
    if (ll == r)
    {
        t[i] = ll;
        return;
    }
    int mid = (ll+r) >> 1;
    make_tree(2*i, ll, mid);
    make_tree(2*i+1, mid+1, r);
    t[i] = (l[t[2*i]] < l[t[2*i+1]]) ? t[2*i] : t[2*i+1];
}

int query_min(int i, int ll, int r, int ql, int qr)
{
    if (ql<=ll && r<=qr) return t[i];
    int mid = (ll+r) >> 1;
    if (qr <= mid) return query_min(2*i, ll, mid, ql, qr);
    if (ql > mid) return query_min(2*i+1, mid+1, r, ql, qr);
    int x = query_min(2*i, ll, mid, ql, mid);
    int y = query_min(2*i+1, mid+1, r, mid+1, qr);
    return (l[x] < l[y]) ? x : y;
}

int LCA(int x, int y)
{
    int i = used[x], j = used[y];
    if (i > j)
    {
        i = i + j;
        j = i - j;
        i = i - j;
    }
    int ans = query_min(1, 1, 2*n, i, j);
    return a[ans];
}

void path(int ver, int&endd, int&color)
{
    c[ver] = color;
    //cout << "*" << ver << " " << color << endl;
    if (ver == endd) return;
    path(p[ver], endd, color);
}

int changes(int last, int ver, int&endd, int ans)
{
    int k = (c[last] != c[ver]) ? 1 : 0;
    ans += k;
    if (ver == endd) return ans;
    return changes(ver, p[ver], endd, ans);
}

void dfs(int ver, int color)
{
    used1[ver] = true;
    c[ver] = color;
    int i, len = v[ver].size();
    for (i=0; i<len; ++i)
    {
        if (!used[v[ver][i]])
            dfs(v[ver][i], color);
    }
}

void solve()
{
    DFS(1, 1, 0);
    make_tree(1, 1, 2*n);

    cin >> q ;
    int i, type, x, y, answer, color, endd;
    for (i=1; i<=q; ++i)
    {
        cin >> type >> x >> y ;
        if (type == 1)
        {
            cin >> color ;
            endd = LCA(x, y);
            path(x, endd, color);
            path(y, endd, color);
        }
        else if (type == 2)
        {
            memset(used1, 0, sizeof(used1));
            dfs(x, y);
        }
        else
        {
            endd = LCA(x, y);
            answer = changes(x, x, endd, 0);
            answer += changes(y, y, endd, 0);
            cout << answer << endl;
        }
    }
}

int main()
{
    read();
    solve();
    return 0;
}

/*
6
1 2
2 6
2 3
3 4
3 5
1 1 3 1 2 1
4
3 6 4
3 6 5
3 2 3
3 1 1
*/