# include <bits/stdc++.h>
using namespace std;
const int maxn = 1e5+5;
vector <int> g[maxn];
short s[maxn];
short ins[maxn],outs[maxn],par[maxn],ids=0;
short a[200005],levels[maxn];
short lca[100005][21];
int n;
struct Segment
{
    short segm[800005];
    void build(int v, int from, int to)
    {
        if(from==to)
        {
            segm[v] = a[from];
            return ;
        }
        int mid = (from+to)/2;
        build(2*v,from,mid);
        build(2*v+1,mid+1,to);
        segm[v] = segm[2*v]+segm[2*v+1];
    }
    int query(int v, int from, int to, int l, int r)
    {
        if(l<=from&&to<=r)return segm[v];
        int ans = 0;
        int mid = (from+to)/2;
        if(l<=mid)ans+=query(2*v,from,mid,l,r);
        if(r>mid)ans+=query(2*v+1,mid+1,to,l,r);
        return ans;
    }
};
Segment S;
void make_lca()
{
    int i,j;
    for(i = 1;i<=n;i++)
        lca[i][0] = par[i];
    for(j = 1;j<=20;j++)
    {
        if(lca[i][j-1]==-1)
            lca[i][j] = -1;
        else
        lca[i][j] = lca[lca[i][j-1]][j-1];
    }
}
void dfs(int v, int _par)
{
    ids++;
    par[v] = _par;
    ins[v] = ids;
    if(_par==-1)levels[v] = 1;
    else
        levels[v] = levels[_par]+1;
    if(_par!=-1 && s[v]!=s[_par])a[ids] = 1;
    for(int i = 0; i < g[v].size();i++)
    {
        int u = g[v][i];
        if(u!=_par)dfs(u,v);
    }
    ids++;
    outs[v] = ids;
     if(_par!=-1 && s[v]!=s[_par])a[ids] = -1;
}
int find_lca(int a, int b)
{
    if(levels[a]>levels[b])swap(a,b);
    int i;
    for(i = 20;i>=0;i--)
    {
        if(levels[b]-(1<<i)>=levels[a])
        {
            b = lca[b][i];
        }
    }

    if(a==b)return a;
    for(i = 20;i>=0;i--)
    { //cout<<a<<" "<<b<<endl;
        if(lca[a][i]!=lca[b][i])
        {
            a = lca[a][i];
            b = lca[b][i];
        }
    }
    return par[a];
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int u,v,i,j;
    cin>>n;
    for(i  = 1;i<n;i++)
    {
        cin>>u>>v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for(i = 1;i<=n;i++)cin>>s[i];

    dfs(1,-1);
   // for(i = 1;i<=ids;i++)cout<<a[i]<<" ";
   // cout<<endl;
  //  for(i = 1;i<=n;i++)cout<<ins[i]<<" & "<<outs[i]<<endl;
    make_lca();
    //cout<<"Ok"<<endl;
    S.build(1,1,ids);
    int q,type;
    cin>>q;
    for(i = 1;i<=q;i++)
    {
        cin>>type;
        if(type==3)
        {
            cin>>u>>v;
            int an = find_lca(u,v);
           // cout<<an<<" "<<S.query(1,1,ids,1,ins[u])<<" : "<<ins[u]<<" "<<S.query(1,1,ids,1,ins[v])<<" "<<S.query(1,1,ids,1,ins[an])<<endl;
            int ans = S.query(1,1,ids,1,ins[u])+S.query(1,1,ids,1,ins[v]) - 2*S.query(1,1,ids,1,ins[an]);
            cout<<ans<<endl;
        }
    }
    return 0;
}
