#include<bits/stdc++.h>
using namespace std;
const int MAXN=1024;
vector<int>g[MAXN];
int par[MAXN];
int dep[MAXN];
int color[MAXN];
void dfs_init(int u,int p)
{
    par[u]=p;
    dep[u]=dep[p]+1;
    for(auto xd:g[u])
    {
        if(xd==p)continue;
        dfs_init(xd,u);
    }
}
int cntchanges(vector<int>v)
{
    int ret=0;
    for(int i=1;i<v.size();i++)
    {
        if(v[i]!=v[i-1])ret++;
    }
    return ret;
}
int main()
{
    int n,q;
    cin>>n;
    for(int i=1;i<n;i++)
    {
        int a,b;
        cin>>a>>b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for(int i=1;i<=n;i++)cin>>color[i];
    cin>>q;
    dfs_init(1,0);
    for(int i=0;i<q;i++)
    {
        int type;
        cin>>type;
        if(type==1)
        {
            int a,b,c;
            cin>>a>>b>>c;
            if(dep[a]<dep[b])swap(a,b);
            while(dep[a]>dep[b])
            {
                color[a]=c;
                a=par[a];
            }
            if(a==b)
            {
                color[a]=c;
            }
            else
            {
                for(;a!=b;)
                {
                    color[a]=c;
                    color[b]=c;
                    a=par[a];
                    b=par[b];
                }
                color[a]=c;
            }
        }
        else if(type==2)
        {
            int a,c;
            cin>>a>>c;
            queue<int>q;
            q.push(a);
            while(!q.empty())
            {
                int u=q.front();
                q.pop();
                color[u]=c;
                for(auto xd:g[u])
                {
                    if(xd==par[u])continue;
                    q.push(xd);
                }
            }
        }
        else if(type==3)
        {
            vector<int>v1;
            vector<int>v2;
            int a,b;
            cin>>a>>b;
            if(dep[a]<dep[b])swap(a,b);
            while(dep[a]>dep[b])
            {
                v1.push_back(color[a]);
                a=par[a];
            }
            for(;a!=b;)
            {
                v1.push_back(color[a]);
                v2.push_back(color[b]);
                a=par[a];
                b=par[b];
            }
            v1.push_back(color[a]);
            v2.push_back(color[b]);
            reverse(v2.begin(),v2.end());
            for(int j=0;j<v2.size();j++)
            {
                v1.push_back(v2[j]);
            }
            cout<<cntchanges(v1)<<endl;
        }
    }
return 0;
}
