#include<bits/stdc++.h>
using namespace std;
const int MAXN=1e5+6;
const int lg=20;
vector<int>g[MAXN];
int par[MAXN][lg];
int uneq[MAXN];
int uneqpref[MAXN];
int dep[MAXN];
int color[MAXN];
int time_in[MAXN];
int time_out[MAXN];
struct segment_tree
{
    int tree[4*MAXN];
    int last_upd[4*MAXN];
    int op=0;
    void update(int l,int r,int idx,int ql,int qr,int val)
    {
        if(qr<l)return;
        if(ql>r)return;
        if(l>=ql&&r<=qr)
        {
            last_upd[idx]=++op;
            tree[idx]=val;
            return;
        }
        int mid=(l+r)/2;
        update(l,mid,idx*2,ql,qr,val);
        update(mid+1,r,idx*2+1,ql,qr,val);
    }
    pair<int,int> query(int l,int r,int idx,int q)
    {

        pair<int,int>t1;
        t1=make_pair(last_upd[idx],tree[idx]);
        if(l==r)return t1;
        int mid=(l+r)/2;
        if(q<=mid)return max(t1,query(l,mid,idx*2,q));
        if(q>mid)return max(t1,query(mid+1,r,idx*2+1,q));
    }
}ogi,ogic;
int n,q;
int getpref(int u)
{
    return ogi.query(1,n,1,time_in[u]).second;
}
int getcol(int u)
{
    return ogic.query(1,n,1,time_in[u]).second;
}
int t=0;
void dfs_init(int u,int p)
{
    time_in[u]=++t;
    par[u][0]=p;
    for(int step=1;step<lg;step++)
    {
        par[u][step]=par[par[u][step-1]][step-1];
    }
    dep[u]=dep[p]+1;
    if(color[u]!=color[p])
    {
        uneq[u]=1;
    }
    uneqpref[u]=uneqpref[p]+uneq[u];
    //cout<<u<<" -> "<<uneqpref[u]<<endl;
    for(auto xd:g[u])
    {
        if(xd==p)continue;
        dfs_init(xd,u);
    }
    time_out[u]=t;
}
int lca(int a,int b)
{
    if(dep[a]<dep[b])swap(a,b);
    int dif=dep[a]-dep[b];
    for(int i=0;i<lg;i++)
    {
        if(dif&(1<<i))
        {
            a=par[a][i];
        }
    }
    if(a==b)return a;
    for(int i=lg-1;i>=0;i--)
    {
        if(par[a][i]!=par[b][i])
        {
            a=par[a][i];
            b=par[b][i];
        }
    }
    return par[a][0];
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    for(int i=1;i<n;i++)
    {
        int a,b;
        cin>>a>>b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for(int i=1;i<=n;i++)cin>>color[i];
    dfs_init(1,0);
    for(int i=1;i<=n;i++)
    {
        ogi.update(1,n,1,time_in[i],time_in[i],uneqpref[i]);
        ogic.update(1,n,1,time_in[i],time_in[i],color[i]);
    }
    /*for(int i=1;i<=n;i++)
    {
        cout<<i<<" : "<<uneqpref[i]<<endl;
    }*/
    /*for(int i=1;i<=n;i++)
    {
        cout<<time_in[i]<<" "<<time_out[i]<<endl;
    }*/
    cin>>q;
    for(int i=0;i<q;i++)
    {
        int t,a,b;
        cin>>t>>a>>b;
        if(t==3)
        {
            int l=lca(a,b);
            cout<<getpref(a)+getpref(b)-getpref(l)*2<<endl;
        }
        else
        {
            int c;
            if(a!=1)c=getcol(par[a][0]);
            else c=-1;
            int pref=getpref(a);
            if(b!=c&&c==getcol(a))
            {
                pref++;
            }
            else if(b==c&&c!=getcol(a))
            {
                pref--;
            }
            ogi.update(1,n,1,time_in[a],time_out[a],pref);
            ogic.update(1,n,1,time_in[a],time_out[a],b);
        }
    }
return 0;
}
