#include<bits/stdc++.h>
using namespace std;
const int MAXN=1e5+6;
const int lg=20;
vector<int>g[MAXN];
int st[MAXN];
bool heavy[MAXN];
int lowest_heavy[MAXN];
int n,q;
int dep[MAXN];
int colors[MAXN];
int par[MAXN][lg];
vector<int>heavy_path[MAXN];
struct node
{
    int cnt_changes;
    int leftmost;
    int rightmost;
};
node mergen(node n1,node n2)
{
    node ret;
    ret.leftmost=n1.leftmost;
    ret.rightmost=n2.rightmost;
    ret.cnt_changes=n1.cnt_changes+n2.cnt_changes;
    if(n1.rightmost!=n2.leftmost)ret.cnt_changes++;
    return ret;
}
node rev(node t)
{
    swap(t.leftmost,t.rightmost);
    return t;
}
struct segment_tree
{
    vector<node>tree;
    vector<int>lazy;
    vector<int>col;
    int m;
    void build(int l,int r,int idx)
    {
        if(l==r)
        {
            tree[idx]={0,col[l-1],col[l-1]};
            return;
        }
        int mid=(l+r)/2;
        build(l,mid,idx*2);
        build(mid+1,r,idx*2+1);
        tree[idx]=mergen(tree[idx*2],tree[idx*2+1]);
    }
    void init(vector<int>colors)
    {
        tree=vector<node>(colors.size()*4);
        lazy=vector<int>(colors.size()*4,0);
        col=colors;
        m=colors.size();
        build(1,m,1);
    }
    void push(int l,int r,int idx)
    {
        if(lazy[idx]==0)return;
        tree[idx].cnt_changes=0;
        tree[idx].leftmost=lazy[idx];
        tree[idx].rightmost=lazy[idx];
        if(l!=r)
        {
            lazy[idx*2]=lazy[idx];
            lazy[idx*2+1]=lazy[idx];
        }
        lazy[idx]=0;
    }
    void update(int l,int r,int idx,int ql,int qr,int cvqt)
    {
        push(l,r,idx);
        if(l>qr)return;
        if(r<ql)return;
        if(l>=ql&&r<=qr)
        {
            lazy[idx]=cvqt;
            push(l,r,idx);
            return;
        }
        int mid=(l+r)/2;
        update(l,mid,idx*2,ql,qr,cvqt);
        update(mid+1,r,idx*2+1,ql,qr,cvqt);
        tree[idx]=mergen(tree[idx*2],tree[idx*2+1]);
    }
    node query(int l,int r,int idx,int ql,int qr)
    {
        push(l,r,idx);
        if(l>=ql&&r<=qr)return tree[idx];
        int mid=(l+r)/2;
        if(qr<=mid)return query(l,mid,idx*2,ql,qr);
        if(ql>mid)return query(mid+1,r,idx*2+1,ql,qr);
        return mergen(query(l,mid,idx*2,ql,qr),query(mid+1,r,idx*2+1,ql,qr));
    }
}t[MAXN];
node bruh[MAXN];
void dfs_init(int u,int p)
{
    st[u]=1;
    par[u][0]=p;
    for(int step=1;step<lg;step++)
    {
        par[u][step]=par[par[u][step-1]][step-1];
    }
    dep[u]=dep[p]+1;
    //cout<<u<<" -> "<<uneqpref[u]<<endl;
    for(auto xd:g[u])
    {
        if(xd==p)continue;
        dfs_init(xd,u);
        st[u]+=st[xd];
    }
    for(auto xd:g[u])
    {
        if(xd==p)continue;
        if(st[xd]*2>st[u])
        {
            heavy[xd]=1;
        }
    }
}
int lca(int a,int b)
{
    if(dep[a]<dep[b])swap(a,b);
    int dif=dep[a]-dep[b];
    for(int i=0;i<lg;i++)
    {
        if(dif&(1<<i))
        {
            a=par[a][i];
        }
    }
    if(a==b)return a;
    for(int i=lg-1;i>=0;i--)
    {
        if(par[a][i]!=par[b][i])
        {
            a=par[a][i];
            b=par[b][i];
        }
    }
    return par[a][0];
}
void dfs_init_hld(int u,int p)
{
    if(heavy[u]==1&&heavy[p]==0)
    {
        lowest_heavy[u]=u;
        heavy_path[u]={u};
    }
    else if(heavy[u])
    {
        lowest_heavy[u]=lowest_heavy[p];
        heavy_path[lowest_heavy[u]].push_back(u);
    }
    for(auto xd:g[u])
    {
        if(xd==p)continue;
        dfs_init_hld(xd,u);
    }
}
node query(int a,int b)
{
    //cout<<a<<" "<<b<<endl;
    node ret;
    if(heavy[a]==0)
    {
        ret=bruh[a];
        //cout<<"light a"<<endl;
        if(a==b)return ret;
        else return mergen(query(par[a][0],b),ret);
    }
    else
    {
        //cout<<"heavy a"<<endl;
        int c=lowest_heavy[a];
        //cout<<c<<" "<<dep[c]<<" "<<dep[b]<<endl;
        if(dep[c]<=dep[b])
        {
            int idx1=dep[b]-dep[c]+1;
            int idx2=dep[a]-dep[c]+1;
            return t[c].query(1,t[c].m,1,idx1,idx2);
        }
        else
        {
            int idx1=1;
            int idx2=dep[a]-dep[c]+1;
            return mergen(query(par[c][0],b),t[c].query(1,t[c].m,1,idx1,idx2));
        }
    }
}
void update(int a,int b,int c)
{
    if(heavy[a]==0)
    {
        bruh[a]={0,c,c};
        if(a==b)return;
        update(par[a][0],b,c);
    }
    else
    {
        int d=lowest_heavy[a];
        if(dep[d]<=dep[b])
        {
            int idx1=dep[b]-dep[d]+1;
            int idx2=dep[a]-dep[d]+1;
            t[d].update(1,t[d].m,1,idx1,idx2,c);
        }
        else
        {
            int idx1=1;
            int idx2=dep[a]-dep[d]+1;
            t[d].update(1,t[d].m,1,idx1,idx2,c);
            update(par[d][0],b,c);
        }
    }
}
int main()
{
    cin>>n;
    for(int i=1;i<n;i++)
    {
        int a,b;
        cin>>a>>b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for(int i=1;i<=n;i++)cin>>colors[i];
    dfs_init(1,0);
    dfs_init_hld(1,0);
    /*cout<<"heavy:\n";
    for(int i=1;i<=n;i++)cout<<heavy[i]<<" ";
    cout<<endl;*/
    for(int i=1;i<=n;i++)
    {
        if(heavy_path[i].size()>0)
        {
            vector<int>cvetove;
            for(auto xd:heavy_path[i])
            {
                cvetove.push_back(colors[xd]);
            }
            t[i].init(cvetove);
        }
        else
        {
            bruh[i]={0,colors[i],colors[i]};
        }
    }
    cin>>q;
    for(int i=0;i<q;i++)
    {
        int type;
        cin>>type;
        if(type==1)
        {
            int u,v,c;
            cin>>u>>v>>c;
            int w=lca(u,v);
            update(u,w,c);
            update(v,w,c);
        }
        else
        {
            int u,v;
            cin>>u>>v;
            int w=lca(u,v);
            //cout<<"lca is "<<w<<endl;
            node p1=query(u,w);
            //cout<<"?1\n";
            node p2=query(v,w);
            //cout<<"?2\n";
            p1=rev(p1);
            /*cout<<"p1:\n";
            cout<<p1.leftmost<<" "<<p1.cnt_changes<<" "<<p1.rightmost<<endl;
            cout<<"p2:\n";
            cout<<p2.leftmost<<" "<<p2.cnt_changes<<" "<<p2.rightmost<<endl;*/
            p1=mergen(p1,p2);
            cout<<p1.cnt_changes<<endl;
        }
    }
return 0;
}
