#include<bits/stdc++.h>
using namespace std;

typedef long long ll;

const ll MAX=1010;

vector<ll> v[MAX],euler;
ll timefirst[MAX];
ll binpar[MAX*8];
ll depth[MAX];
ll color[MAX];
ll par[MAX];
ll n;

void makebintree(ll pos,ll l,ll r){
  if(l==r){
    binpar[pos]=euler[l];
    return ;
    }

  ll mid=(l+r)/2;
  makebintree(pos*2,l,mid);
  makebintree(pos*2+1,mid+1,r);
  if(depth[binpar[pos*2]]<depth[binpar[pos*2+1]])binpar[pos]=binpar[pos*2];
  else binpar[pos]=binpar[pos*2+1];
  }

ll querparans;
void querpar(ll pos,ll l,ll r,ll ql,ll qr){
  if(ql<=l && r<=qr){
    if(querparans==-1 || depth[binpar[pos]]<depth[querparans])querparans=binpar[pos];
    }
  else if(l>qr || r<ql)return ;
  else {
    ll mid=(l+r)/2;
    querpar(pos*2,l,mid,ql,qr);
    querpar(pos*2+1,mid+1,r,ql,qr);
    }
  }

ll qpar(ll a,ll b){
  querparans=-1;
  a=timefirst[a];
  b=timefirst[b];
  if(a>b)swap(a,b);
  querpar(1,0,euler.size()-1,a,b);
  return querparans;
  }

void dfspardeptheu(ll pos,ll p,ll d){
  par[pos]=p;
  depth[pos]=d;
  euler.push_back(pos);
  timefirst[pos]=euler.size()-1;
  for(ll i : v[pos]){
    if(i!=p){
      dfspardeptheu(i,pos,d+1);
      euler.push_back(pos);
      }
    }
  }

void colorsub(ll pos,ll c){
  color[pos]=c;
  for(ll i : v[pos]){
    if(i==par[pos])continue;
    colorsub(i,c);
    }
  }

int main(){

cin>>n;
for(ll i=1,x,y;i<n;++i){
  cin>>x>>y;
  v[x].push_back(y);
  v[y].push_back(x);
  }
for(ll i=1;i<=n;++i)cin>>color[i];

dfspardeptheu(1,-1,1);
makebintree(1,0,euler.size()-1);

ll q;
cin>>q;
while(q--){
  ll t;
  cin>>t;
  if(t==1){
    ll a,b,c,pp;
    cin>>a>>b>>c;
    pp=qpar(a,b);
    while(a!=pp){color[a]=c;a=par[a];}
    while(b!=pp){color[b]=c;b=par[b];}
    color[pp]=c;
    }
  else if(t==2){
    ll a,c;
    cin>>a>>c;
    colorsub(a,c);
    }
  else {
    ll a,b,pp,res=0;
    cin>>a>>b;
    pp=qpar(a,b);
    while(a!=pp){
      if(color[a]!=color[par[a]])++res;
      a=par[a];
      }
    while(b!=pp){
      if(color[b]!=color[par[b]])++res;
      b=par[b];
      }
    cout<<res<<endl;
    }
  }

return 0;
}
/*
6
1 2
2 6
2 3
3 4
3 5
*/
