#include <iostream>
#include "gcd.h"
using namespace std;

typedef unsigned long long ull;

ull query(ull a, ull b);

ull play(ull MAX_X)
{
    ull b = 1;
    while (b < MAX_X) b <<= 1;

    ull a = 0, q;
    while ((q = query(a, b)) != b)
    {
        a += q;
        if (q == b / 2) break;
        if (q == b / 8) break;
    }
    if (q == b / 8)
    {
        a += 2 * q;
        ull t = query(a, b);
        if (t == 8 * q) {}
        else if (t == 4 * q)
        {
            q *= 4;
            a += q;
        }
        else
        {
            a -= 2 * q;
            q *= 4;
            a += q;
        }
    }
    return (b - a) % b;
}