#include <iostream>
#include "gcd.h"
using namespace std;

typedef unsigned long long ull;

ull query(ull a, ull b);

ull play(ull MAX_X)
{
    ull b = 1;
    while (b < MAX_X) b <<= 1;

    int t = rand() % 101;

    if (t == 97)
    {
        ull a = 0, c, q;
        while ((q = query(a, b)) != b)
        {
            a += q;
            c = b - 2 * q;
            if (query(a + c, b) == b) break;
            c = 0;
            if (q == b / 2) break;
        }
        return (b - (a + c)) % b;
    }
    else
    {
        ull a = 0, q;
        while ((q = query(a, b)) != b)
        {
            a += q;
            if (q == b / 2) break;
            if (q == b / 8) break;
        }
        if (q == b / 8)
        {
            a += 2 * q;
            ull t = query(a, b);
            if (t == 8 * q) {}
            else if (t == 4 * q)
            {
                q *= 4;
                a += q;
            }
            else
            {
                a -= 2 * q;
                t = query(a, b);
                if (t == 4 * q)
                {
                    q *= 4;
                    a += q;
                }
            }
        }
        return (b - a) % b;
    }
}