#include <iostream>
#define endl '\n'
using namespace std;

const int MOD = 1000000007;

int tab[30][30], cnt[30][30][2], outp[30];

long long modpow(long long a, long long b)
{
    long long ret = 1;
    while (b)
    {
        if (b & 1) ret = (ret * a) % MOD;
        b >>= 1;
        a = (a * a) % MOD;
    }
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    string s;
    cin >> s;

    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= m; ++ i)
    {
        char a, b, c;
        cin >> a >> b >> c;
        tab[a - 'A' + 1][b - 'A' + 1] = c - 'A' + 1;
    }

    int sz = s.size();

    for (int i = 0; i < sz - 1; ++ i)
    {
        cnt[s[i] - 'A' + 1][s[i + 1] - 'A' + 1][0]++;
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= 26; ++ j)
        {
            for (int k = 1; k <= 26; ++ k)
            {
                if (tab[j][k] == 0)
                {
                    cnt[j][k][1] += cnt[j][k][0];
                    cnt[j][k][1] %= MOD;
                }
                else
                {
                    cnt[j][tab[j][k]][1] += cnt[j][k][0];
                    cnt[j][tab[j][k]][1] %= MOD;

                    cnt[tab[j][k]][k][1] += cnt[j][k][0];
                    cnt[tab[j][k]][k][1] %= MOD;
                }
            }
        }

        for (int j = 1; j <= 26; ++ j)
        {
            for (int k = 1; k <= 26; ++ k)
            {
                cnt[j][k][0] = cnt[j][k][1];
                cnt[j][k][1] = 0;
            }
        }
    }

    for (int j = 1; j <= 26; ++ j)
    {
        for (int k = 1; k <= 26; ++ k)
        {
            outp[j] += cnt[j][k][0];
            outp[j] %= MOD;

            outp[k] += cnt[j][k][0];
            outp[k] %= MOD;
        }
    }

    outp[s[0] - 'A' + 1]++;
    outp[s[0] - 'A' + 1] %= MOD;

    outp[s[sz - 1] - 'A' + 1]++;
    outp[s[sz - 1] - 'A' + 1] %= MOD;

    for (int i = 1; i <= 26; ++ i)
    {
        cout << char(i - 1 + 'A') << " " << (outp[i] * modpow(2, MOD - 2)) % MOD << endl;
    }

    return 0;
}
