#include <iostream>
using namespace std;
const int MAXN=677;
const long long mod=1e9+7;
int ma[256], kop[128][3];
char op[32], q[MAXN];
long long start[MAXN], t[MAXN][MAXN], ans[256], cnt[MAXN];
long long res[MAXN][MAXN], d[MAXN][MAXN];
int br_let, br;
void mult(long long a[][MAXN], long long b[][MAXN], long long c[][MAXN]) {
    for (int i=0;i<br;i++) {
        for (int j=0;j<br;j++) d[i][j]=0;
    }
    for (int i=0;i<br;i++) {
        for (int j=0;j<br;j++) {
            for (int k=0;k<br;k++) {
                d[i][j]+=(a[i][k]*b[k][j])%mod;
            }
        }
    }
    for (int i=0;i<br;i++) {
        for (int j=0;j<br;j++) c[i][j]=d[i][j]%mod;
    }
}
void print_table(long long a[][MAXN]) {
    for (int i=0;i<br;i++) {
        for (int j=0;j<br;j++) {
            cout << a[i][j] << ' ';
        }
        cout << endl;
    }
}
void table_pow(int x) {
    while (x>0) {
        if (x%2==1) mult(t,res,res);
        ///print_table(t);
        mult(t,t,t);
        x/=2;
    }
    ///print_table(res);
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string str;
    int num1, num2;
    char c1, c2, c3;
    int n, m;
    cin >> str;
    cin >> n >> m;
    for (int i=0;i<256;i++) ma[i]=-1;
    br_let=0;
    for (int i=0;i<str.size();i++) {
        if (ma[str[i]]==-1) {
            ma[str[i]]=br_let;
            op[br_let]=str[i];
            br_let++;
        }
    }
    for (int i=0;i<m;i++) {
        cin >> c1 >> c2 >> c3;
        if (ma[c1]==-1) {
            ma[c1]=br_let;
            op[br_let]=c1;
            br_let++;
        }
        if (ma[c2]==-1) {
            ma[c2]=br_let;
            op[br_let]=c2;
            br_let++;
        }
        if (ma[c3]==-1) {
            ma[c3]=br_let;
            op[br_let]=c3;
            br_let++;
        }
        kop[i][0]=ma[c1];
        kop[i][1]=ma[c2];
        kop[i][2]=ma[c3];
    }
    for (int i=0;i<m;i++) {
        num1=kop[i][0]*br_let+kop[i][1];
        num2=kop[i][0]*br_let+kop[i][2];
        t[num1][num2]=1;
        num2=kop[i][2]*br_let+kop[i][1];
        t[num1][num2]=1;
        q[num1]=op[kop[i][2]];
    }
    br=br_let*br_let;
    for (int i=0;i<br;i++) {
        if (q[i]==0) t[i][i]=1;
        res[i][i]=1;
    }
    table_pow(n-1);
    for (int i=1;i<str.size();i++) {
        num1=ma[str[i-1]]*br_let;
        num1+=ma[str[i]];
        start[num1]++;
    }
    for (int i=0;i<br;i++) {
        if (start[i]!=0) {
            for (int j=0;j<br;j++) cnt[j]=(cnt[j]+start[i]*res[i][j])%mod;
        }
    }
    for (int i=0;i<br;i++) {
        c1=op[i/br_let];
        ///cout << c1 << ' ' << op[i%br_let] << ' ' << cnt[i] << endl;
        ans[c1]+=cnt[i];
        if (q[i]!=0) ans[q[i]]+=cnt[i];
    }
    ans[str[str.size()-1]]++;
    for (int i=0;i<26;i++) {
        c1='A'+i;
        cout << c1 << ' ' << ans[c1]%mod << endl;
    }
    return 0;
}
/**
NNCB
1 16
CH B
HH N
CB H
NH C
HB C
HC B
HN C
NN C
BH H
NC B
NB B
BN B
BB N
BC B
CC N
CN C

NBBN
3 3
NB N
BB N
BN N
**/
