#include "gcd.h"
#include <iostream>
#include <vector>
#include <algorithm>
const int base = 12;

std::vector < int > v[base], rem[base], ans;

int log(int x, int base1)
{
    int ans = 0;
    while (x >= 1) ++ans, x /= base1;
    return ans;
}

ull play(ull max)
{
    for (int i = 0 ; i < base ; ++i)
    {
        v[i].clear();
        rem[i].clear();
    }

    for (int i = 0 ; i < base ; ++i)
    {
        v[std::__gcd(i, base)].push_back(i);
        rem[std::__gcd(i, base)].push_back(std::__gcd(i+1, base));
    }

    ans.clear();
    int add = 0, curr = base;
    while (curr/base <= max)
    {
        int tryguessing = query(add, curr) / (curr / base);
        int tryguessing1 = -1;
        if (v[tryguessing].size() >= 2) tryguessing1 = query(add + curr/base, curr) / (curr / base);
        // std::cout << "try guessing: " << add << ' ' << curr << ' ' << tryguessing << ' ' << tryguessing1 << '\n';
        for (int i = 0 ; i < v[tryguessing].size() ; ++i)
        {
            if (rem[tryguessing][i] == tryguessing1)
            {
                ans.push_back(v[tryguessing][i] - (curr != base));
                // std::cout << "push digit: " << v[tryguessing][i] - (curr != base) << '\n';
                break;
            }
        }
        if (tryguessing1 == -1) ans.push_back(v[tryguessing][0] - (curr != base));
        add += (base - ans.back()) * (curr/base);
        curr *= base;
    }

    int res = 0;
    bool bl = 0;
    for (int i = ans.size()-1 ; i >= 0 ; --i)
    {
        // std::cout << "in: " << i << ' ' << ans[i] << ' ' << res << '\n';
        bl |= (ans[i] != 0);
        if (bl) res *= base;
        res += ans[i];
    }

    // std::cout << res << '\n';
    return res;
}