#include <iostream>
#define int long long
const int matSize = 700, mod = 1e9+7;

std::string beg;
int n, m;
int base[matSize][matSize];
int ans[matSize][matSize];
int buff[matSize][matSize];
int cnt[matSize], after[matSize], output[26];
bool rules[matSize];
int realMatSize, l;
bool in[26];
int num[26], revert[26];

void copy(int a[][matSize], int b[][matSize])
{
    for (int i = 0 ; i < realMatSize ; ++i)
    {
        for (int j = 0 ; j < realMatSize ; ++j)
        {
            a[i][j] = b[i][j];
        }
    }
}

void mult(int a[][matSize], int b[][matSize])
{
    // std::cout << "multiply\n";
    for (int i = 0 ; i < realMatSize ; ++i)
    {
        for (int j = 0 ; j < realMatSize ; ++j)
        {
            buff[i][j] = 0;
            for (int k = 0 ; k < realMatSize ; ++k)
            {
                buff[i][j] = (buff[i][j] + a[i][k] * b[k][j]) % mod;
            }
        }
    }
    copy(a, buff);
}

void power(int n)
{
    // std::cout << "power: " << n << '\n';
    for (int i = 0 ; i < realMatSize ; ++i) ans[i][i] = 1;
    for (int log = 0 ; (1ll << log) <= n ; ++log)
    {
        // std::cout << "log: " << log << '\n';
        if (n & (1ll << log)) mult(ans, base);
        mult(base, base);
    }
}

int powerNum(int x, int base)
{
    if (base == 0) return 1;
    if (base & 1) return (x * powerNum(x, base-1)) % mod;
    int res = powerNum(x, base/2);
    return (res*res) % mod;
}

int convert(char a, char b)
{
    return (a-'A') * 26 + (b-'A');
}

void solve()
{
    for (char c : beg)
        in[c-'A'] = 1;

//     l = 0;
//     for (int i = 0 ; i < 26 ; ++i)
//     {
//         l += in[i];
//         num[i] = l;
//         if (in[i]) std::cout << "num: " << i << ' ' << num[i] << '\n';
//         revert[num[i]] = i;
//     }
    realMatSize = 680;

    for (int i = 0 ; i < 26 ; ++i)
    {
        num[i] = i;
        revert[i] = i;
    }

    if (beg.size() == 1)
    {
        ++output[beg[0]-'A'];
        for (int i = 0 ; i < 26 ; ++i)
        {
            std::cout << char('A' + i) << ' ' << output[i] << '\n'; 
        }
        return;
    }
 
    for (int i = 0 ; i < matSize ; ++i)
    {
        if (!rules[i]) ++base[i][i];
    }
 
    power(n);
    // std::cout << "powered\n";
    for (int i = 0 ; i < beg.size()-1 ; ++i)
    {
        ++cnt[convert(beg[i], beg[i+1])];
    }

    for (int i = 0 ; i < matSize ; ++i)
    {
        for (int j = 0 ; j < matSize ; ++j)
        {
            after[j] = (after[j] + cnt[i]*ans[i][j]) % mod;
        }
    }

    for (int i = 0 ; i < matSize ; ++i)
    {
        if (after[i] == 0) continue; 
        // std::cout << "after: " << i << ' ' << char(i/26 + 'A') << ' ' << char(i%26 + 'A') << ' ' << after[i] << '\n'; 
        output[revert[i/26]] += after[i];
        output[revert[i%26]] += after[i];
        if (output[revert[i/26]] >= mod) output[revert[i/26]] -= mod;
        if (output[revert[i%26]] >= mod) output[revert[i%26]] -= mod;
    }

    // std::cout << "curr: " << beg.front() << ' ' << beg.back() << ' ' << output[beg.front()-'A'] << ' ' << output[beg.back()-'A'] << '\n';
    ++output[num[beg.front()-'A']];
    ++output[num[beg.back()-'A']];

    for (int i = 0 ; i < 26 ; ++i)
    {
        std::cout << char('A' + i) << ' ' << (in[i] ? (output[num[i]] * powerNum(2, mod-2)) % mod : 0) << '\n';
    }
}

void read()
{
    std::cin >> beg;
    std::cin >> n >> m;
    for (int i = 1 ; i <= m ; ++i)
    {
        char c[2], a, b, res;
        std::cin >> c >> res;
        a = c[0]; b = c[1];
        in[a-'A'] = 1;
        in[b-'A'] = 1;
        in[res-'A'] = 1;
        rules[convert(a, b)] = 1; 
        ++base[convert(a, b)][convert(a, res)];
        ++base[convert(a, b)][convert(res, b)];
    } 
}

void fast_io()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

signed main()
{
    fast_io();
    read();
    solve();

    return 0;
}