#include<bits/stdc++.h>
//#pragma GCC optimise ("O3")
//#pragma GCC target ("sse4")
//#pragma GCC ("unroll-loops")
#define lli long long int
#define endl "\n"
using namespace std;
const lli MAXN=100005;
lli N, Q, c[MAXN], a[MAXN], parent[MAXN], head[MAXN], sz[MAXN], heavy[MAXN], heavy_max[MAXN], pos[MAXN], pos_cnt, vh1, vh2, vh3, dep[MAXN];
vector<lli> undirv[MAXN], v[MAXN], tree[4*MAXN];
unordered_map<lli, lli> m;
void dfs(lli vr){
    sz[vr]=1;
    heavy_max[vr]=0;
    heavy[vr]=-1;
    for(auto to:undirv[vr]){
        if(to!=parent[vr]){
            parent[to]=vr;
            v[vr].push_back(to);
            dep[to]=dep[vr]+1;
            dfs(to);
            sz[vr]+=sz[to];
            if(sz[to]>heavy_max[vr]){
                heavy_max[vr]=sz[to];
                heavy[vr]=to;
            }
        }
    }
    return;
}
void decomposition(lli vr, lli heavy_v){
    head[vr]=heavy_v;
    pos_cnt++;
    pos[vr]=pos_cnt;
    if(heavy[vr]==-1)return;
    decomposition(heavy[vr], heavy_v);
    for(auto to:v[vr]){
        if(to!=heavy[vr]){
            decomposition(to, to);
        }
    }
}
void mergev(lli ind, lli ind1, lli ind2){
    lli p1=0;
    for(lli i=0; i<tree[ind1].size(); i++){
        while(p1<tree[ind2].size() and tree[ind2][p1]<tree[ind1][i]){
            tree[ind].push_back(tree[ind2][p1]);
            p1++;
        }
        tree[ind].push_back(tree[ind1][i]);
    }
    while(p1<tree[ind2].size()){
        tree[ind].push_back(tree[ind2][p1]);
        p1++;
    }
    return;
}
void build(lli ind, lli l, lli r){
    if(l==r){
        tree[ind]={c[l]};
        return;
    }
    lli mid=(l+r)/2;
    build(2*ind, l, mid);
    build(2*ind+1, mid+1, r);
    mergev(ind, 2*ind, 2*ind+1);
    return;
}
lli bin_search(lli ind, lli l, lli r, lli x){
    while(l!=r-1){
        lli mid=(l+r)/2;
        if(tree[ind][mid]<x)l=mid;
        else r=mid;
    }
    if(r!=tree[ind].size() and tree[ind][r]<x)return r;
    if(tree[ind][l]<x)return l;
    return -1;
}
lli query(lli ind, lli l, lli r, lli ql, lli qr){
    if(l>qr or r<ql)return 0;
    if(ql<=l and r<=qr){
        lli ans=bin_search(ind, 0, tree[ind].size(), ql)+1;
        return ans;
    }
    lli mid=(l+r)/2;
    return query(2*ind, l, mid, ql, qr)+query(2*ind+1, mid+1, r, ql, qr);
}
lli find_lca(lli u1, lli v1){
    lli ans=0;
    while(head[u1]!=head[v1]){
        lli pathu=head[u1], pathv=head[v1];
        if(dep[pathu]<dep[pathv]){
            ans+=query(1, 1, N, pos[pathv], pos[v1]);
            v1=parent[pathv];

        }else{
            ans+=query(1, 1, N, pos[pathu], pos[u1]);
            u1=parent[pathu];
        }
    }
    if(pos[u1]>pos[v1])swap(u1, v1);
    ans+=query(1, 1, N, pos[u1], pos[v1]);
    return ans;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>N;
    for(lli i=0; i<N-1; i++){
        cin>>vh1>>vh2;
        undirv[vh1].push_back(vh2);
        undirv[vh2].push_back(vh1);
    }
    dfs(1);
    decomposition(1, 1);
    for(lli i=1; i<=N; i++){
        cin>>a[pos[i]];
    }
    for(lli i=1; i<=N; i++){
        c[i]=m[a[i]];
        m[a[i]]=i;
    }
    build(1, 1, N);
    cin>>Q;
    for(lli i=0; i<Q; i++){
        cin>>vh1>>vh2>>vh3;
        cout<<find_lca(vh2, vh3)<<endl;
    }
    return 0;
}
