#include <iostream>
#include "gcd.h"
using namespace std;
ull gcd(ull a, ull b) {
    if (a < b) {
        swap(a, b);
    }
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}
ull play(ull MAX_X) {
    ull S = 1, q = 1;
    for (ull r = 1; S * r < MAX_X; r++) {
        if (gcd(r, S * q) == 1) {
            ull p = query(0, r);
            S *= p;
            q *= (r / p);
            r = 1;
        }
    }
    return S;
}
