#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
const ll maxc = 17;
const ll mod = 1e9 + 7;
const ll maxm = 130;
struct rule
{
    char a, b, c;
} r[maxm];
ll n, m, k, l;
ll dp[2][maxc][maxc], w[2][maxc], ans[26];
ll idx;
struct matrix
{
    ll a[maxc * maxc][maxc * maxc];

    matrix()
    {
        memset(a, 0, sizeof(a));
    }
    matrix operator * (const matrix &m) const
    {
        matrix res;
        //cout << res.a[0][0] << endl;
        for (int i = 1; i <= idx * idx; i ++)
            for (int j = 1; j <= idx * idx; j ++)
                for (int k = 1; k <= idx * idx; k ++)
                {
                    res.a[i][k] += (a[i][j] * m.a[j][k]) % mod;
                    if (res.a[i][k] >= mod)
                        res.a[i][k] -= mod;
                }

        return res;
    }
};

string s;
unordered_map < char, ll > mp;
unordered_map < ll, char > rev;



ll power(ll base, ll st)
{
    ll ans = 1;
    while(st > 0)
    {
        if (st % 2 == 1)
            ans = (ans * base) % mod;
        base = (base * base) % mod;
        st /= 2;
    }
    return ans;
}
void solve()
{

    cin >> s >> n >> m;
    ll sz = s.size();
    for (ll i = 0; i < sz; i ++)
    {
        if (mp[s[i]] == 0)
            mp[s[i]] = ++ idx, rev[idx] = s[i];
        s[i] = (mp[s[i]] + 'A');
    }
    for (ll i = 1; i <= m; i ++)
    {
        cin >> r[i].a >> r[i].b >> r[i].c;
        if (mp[r[i].a] == 0)
            mp[r[i].a] = ++ idx, rev[idx] = r[i].a;
        if (mp[r[i].b] == 0)
            mp[r[i].b] = ++ idx, rev[idx] = r[i].b;
        if (mp[r[i].c] == 0)
            mp[r[i].c] = ++ idx, rev[idx] = r[i].c;

        r[i].a = (mp[r[i].a] + 'A');
        r[i].b = (mp[r[i].b] + 'A');
        r[i].c = (mp[r[i].c] + 'A');

    }


    /**for (ll i = 0; i < sz; i ++)
    {
        w[0][s[i] - 'A'] ++;
        if (i != sz - 1)
            dp[0][s[i] - 'A'][s[i + 1] - 'A'] ++;
    }*/

    matrix base;
    for (int i = 1; i <= idx; i ++)
        for (int j = 1; j <= idx; j ++)
        {
            int sum = (i - 1) * idx + j;
            base.a[sum][sum] = 1;
        }

    for (int p = 1; p <= m; p ++)
    {
        ll id1 = r[p].a - 'A', id2 = r[p].b - 'A', id3 = r[p].c - 'A';
        ll sum1 = (id1 - 1) * idx + id2;
        base.a[sum1][sum1] --;
        ll sum2 = (id1 - 1) * idx + id3;
        ll sum3 = (id3 - 1) * idx + id2;
        base.a[sum1][sum2] ++;
        base.a[sum1][sum3] ++;
    }
    //cout << "fine" << endl;
    matrix res ;
    ///cout << "here" << endl;
    //matrix res;

    //cout << res.a[0][0] << endl;
    for (int i = 0; i < (int)(s.size()) - 1; i ++)
    {
        int id1 = s[i] - 'A', id2 = s[i + 1] - 'A';
        //cout << id1 << " : " << id2 << endl;
        int sum = (id1 - 1) * idx + id2;
            //cout << s[i] << " " << s[i + 1] << " " << sum << endl;
        res.a[sum][sum] ++;
    }
    ll st = n;
    while(st > 0)
    {
        if (st % 2 == 1)
            res = res * base;
        base = base * base;
        st /= 2;
    }
    //return res;
    ///cout << "out" << endl;

    ll cur = n % 2;
    for (int i1 = 1; i1 <= idx; i1 ++)
        for (int j1 = 1; j1 <= idx; j1 ++)
            for (int i2 = 1; i2 <= idx; i2 ++)
                for (int j2 = 1; j2 <= idx; j2 ++)
                {
                    int sum1 = (i1 - 1) * idx + j1, sum2 = (i2 - 1) * idx + j2;
                    /*if (res.a[sum1][sum2] > 0)
                    {
                        /cout << i1 << " " << j1 << " " << i2 << " " << j2 << endl;
                    }*/
                    dp[cur][i2][j2] += res.a[sum1][sum2];
                    if (dp[cur][i2][j2] >= mod)
                        dp[cur][i2][j2] -= mod;
                }
    /**for (ll st = 1; st <= n; st ++)
    {
        ll cur = st % 2, bef = (st - 1) % 2;
        for (ll i = 1; i <= idx; i ++)
            for (ll j = 1; j <= idx; j ++)
                dp[cur][i][j] = dp[bef][i][j];

        for (ll i = 1; i <= idx; i ++)
            w[cur][i] = w[bef][i];

        for (ll p = 1; p <= m; p ++)
        {
            ll id1 = r[p].a - 'A', id2 = r[p].b - 'A', id3 = r[p].c - 'A';
            ll t = dp[bef][id1][id2];
            dp[cur][id1][id2] -= t;
            dp[cur][id1][id2] += mod;
            if (dp[cur][id1][id2] >= mod)
                dp[cur][id1][id2] -= mod;

            dp[cur][id1][id3] += t;
            dp[cur][id3][id2] += t;
            if (dp[cur][id1][id3] >= mod)
                dp[cur][id1][id3] -= mod;
            if (dp[cur][id3][id2] >= mod)
                dp[cur][id3][id2] -= mod;

            w[cur][id3] += t;
            if (w[cur][id3] >= mod)
                w[cur][id3] -= mod;
        }
    }*/


    for (ll i = 1; i <= idx; i ++)
        for (ll j = 1; j <= idx; j ++)
        {
            ans[rev[i] - 'A'] += dp[cur][i][j];
            if (ans[rev[i] - 'A'] >= mod)
                ans[rev[i] - 'A'] -= mod;
            ans[rev[j] - 'A'] += dp[cur][i][j];
            if (ans[rev[j] - 'A'] >= mod)
                ans[rev[j] - 'A'] -= mod;
        }

    //for (int i = 0; i < 26; i ++ )
    //if (ans[i] != 0)
      //  cout << (char)(i + 'A') << " - " << ans[i] << endl;

    ans[rev[s[0] - 'A'] - 'A'] ++;
    if (  ans[rev[s[0] - 'A'] - 'A'] >= mod)
        ans[rev[s[0] - 'A'] - 'A'] -= mod;
    if (sz != 1)
    {

        ans[rev[s.back() - 'A'] - 'A'] ++;
        if (ans[rev[s.back() - 'A'] - 'A'] >= mod)
            ans[rev[s.back() - 'A'] - 'A'] -= mod;
    }
    for (ll i = 0; i < 26; i ++)
        cout << (char)(i + 'A') << " " << (ans[i] * power((ll)(2), mod - 2)) % mod << endl;


}

int main()
{
    speed();
    solve();
    return 0;
}
/**


NNCBNNCBCNCNNBADASRATASFASTASEDASASFGSGADAS
125312 16
CH B
HH N
CB H
NH C
HB C
HC B
HN C
NN C
BH H
NC B
NB B
BN B
BB N
BC B
CC N
CN C

*/
